# Calculates XS, XE, and XTICK

xtick() {
  _FILE=$1

  _XS=`awk -v fact=$FACT 'BEGIN {min= 9999.9} NR > 4 {if ($1 < min) min=$1} END {print int(min*fact-1.0)}' $_FILE`
  _XE=`awk -v fact=$FACT 'BEGIN {max=-9999.9} NR > 4 {if ($1 > max) max=$1} END {print int(max*fact+1.0)}' $_FILE`

  XS=${XS:=$_XS}
  XE=${XE:=$_XE}

  if [ $XE -le $XS ]; then
    echo "XE = $XE is not larger than XS = $XS !"
    exit 9
  fi

  _W=`echo "scale=5; $XE-($XS-0.0)" | bc`
  _A=`echo "scale=0; $_W/3.0" | bc`
  _F=1
  if [ $_A -lt 1 ]; then
    _A=1
  fi

  XTICK="a${_A}f${_F}"
}
