c **********************************************************************
c *   Converts binary format into GMT format                           *
c *                                                                    *
c *   Input parameters:                                                *
c *     f_name        : File name               (Element_Run.Restart)  *
c *                   : For example, u___01.01                         *
c *     irec          : Record number to be extracted                  *
c *     irend         : If specified, last record number               *
c *                   : Quantity is averaged from irec to irend.       *
c *                                                                    *
c *                                   Dec/2009  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "../post/sub_data_dir.f"
c
      parameter ( mx=502, my=502, mz=201 )
c
      character (len=9) :: f_name
      double precision  dat(mx,mz,my), ave
      dimension         prf(mz)
c
      namelist  /les1/  nrun, nstep,  iout,  jout,  lout
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, phour, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
c
      namelist  /figs/ f_name, irec, irend
c
      f_name   = ''
      irec     = 1
      irend    = 0
c
      read (5,nml=figs)
c
      irsta    = irec
c
      if ( f_name(8:9) .eq. '00' ) then
        open (10,file='para'//f_name(5:7)//'01',status='old',iostat=ios)
        irec = 0
      else
        open (10,file='para'//f_name(5:9),status='old',iostat=ios)
      end if
      if ( ios .ne. 0 ) stop 'para-file not found.'
c
      if ( irend .lt. irsta ) irend = irsta
c
      read (10,*) lx, lz, ly
      read (10,*) nx, nz, ny
c
      if ( lx .gt. mx .or. ly .gt. my .or. lz .gt. mz ) then
                        write(6,*) 'nx, ny, nz =', nx, ny, nz
                        stop 'Grid number is large!'
      end if
c
      read (10,nml=les1)
      read (10,nml=les2)
c
      do k = 1,nz
        prf(k) = 0.0
      end do
c
      call sub_data_open ( f_name(5:9),f_name(1:4), 11, lx,lz,ly )
c
      do ir = irsta,irend
        jrec = ir
        call sub_data_input ( 11,jrec, mx,mz,my, lx,lz,ly, dat )
c
        do k = 1,nz
          ave = 0.0
          do j = 2,ny-1
          do i = 2,nx-1
            ave = ave +dat(i,k,j)
          end do
          end do
          prf(k) = prf(k) +ave/dble((nx-2)*(ny-2))
        end do
c
        ntime = ir -irsta +1
      end do
c
  100 close(10)
      close(11)
c
      if ( ntime .eq. 0 ) ntime = 1
      irend = ntime +irec -1
c
      ihs  = jmin +nint(min(nstot-nstep+jout*irec, nstot)*dt)/60
      ihs  = ihs/60*100 +mod(ihs,60)
      ihe  = jmin +nint(min(nstot-nstep+jout*irend,nstot)*dt)/60
      ihe  = ihe/60*100 +mod(ihe,60)
c
      apls = 0.0; if ( f_name(1:2) .eq. 't_' ) apls = tref
      zpls = 0.5; if ( f_name(1:2) .eq. 'w_' .or.
     :                 f_name(1:2) .eq. 'zw' ) zpls = 0.0
c
      write(6,'(2i5.4)') ihs, ihe
      write(6,*) dz
      write(6,*) dz*nz
      write(6,*) 'profile'
c
      do k = 1,nz
        write(6,*) prf(k)/real(ntime)+apls, dz*(k-1+zpls)
      end do
c
      stop
      end
