#
#  Searches an inflection point in the lowest layer after rotating
#
#  ang is specified through '-v ang=$ANG'
#
{
  u[NR] = $1;
  v[NR] = $3;
  z[NR] = $2;
}

END {
  d2r  = 3.141593/180.0;

  geov = sqrt ( u[NR]^2+v[NR]^2 );
  geod = atan2( v[NR], u[NR] ) + ( ang + 90.0 )*d2r;
  cs   = cos( geod );
  sn   = sin( geod );

  for ( k = 1; k <= NR; k++ ) {
    ur[k] = ( u[k]*cs + v[k]*sn ) / geov;

    print ang, ur[k], z[k];
  }

    dif1 = ur[ 3 ] + ur[ 1 ] - 2.0*ur[ 2 ];
  for ( k = 3; k <  NR; k++ ) {
    nr   = k;
    dif2 = ur[k+1] + ur[k-1] - 2.0*ur[ k ];
    if ( dif1*dif2 <= 0.0 ) break;
    dif1 = dif2;
  }

  dp  = dif1 / ( dif2-dif1 ); if ( dp < 0.0 ) dp = -dp;
  up  = ur[nr]*dp + ur[nr-1]*(1.0-dp);
  zp  = z [nr]*dp + z [nr-1]*(1.0-dp);

  print "point", up, zp;
}
