#!/bin/sh

IQNT=2

CDEL=0.5
PART=5

. ./GetOpts

F_OUT=test
SDIR=$HOME/les_for_es/pod
GDIR=$DDIR/Movie

cd $DDIR

$SDIR/pod_sdh << EOF1 > $GDIR/$F_OUT.dvc
&pod1
r_num = $N_IN
irsta = 1
irend = 999
/
&pod3
iqnt   = $IQNT
kplane = $KPLANE
/
EOF1

cd $GDIR

TMST=`awk 'NR == 1 {print $1}' $F_OUT.dvc`
TMED=`awk 'NR == 1 {print $2}' $F_OUT.dvc`
DX=`awk 'NR == 2 {print $1}' $F_OUT.dvc`
DY=`awk 'NR == 2 {print $2}' $F_OUT.dvc`
DZ=`awk 'NR == 2 {print $3}' $F_OUT.dvc`
XP=`awk 'NR == 3 {print $1}' $F_OUT.dvc`
YP=`awk 'NR == 3 {print $2}' $F_OUT.dvc`
ZT=`awk 'NR == 3 {print $3}' $F_OUT.dvc`
ZP=${ZP:=$ZT}
PLANE=`awk 'NR == 4 {print $1}' $F_OUT.dvc`

. $SDIR/../gmt/SetAxes

if   [ "$PLANE" = "y-z" ]; then
  XLAB="n@-y@-"; YLAB="z (km)"
elif [ "$PLANE" = "x-z" ]; then
  XLAB="n@-x@-"; YLAB="z (km)"
else
  XLAB="n@-x@-"; YLAB="n@-y@-"
fi

XDIS=`echo "scale=2; $XDIS/$PART" | bc`
YDIS=`echo "scale=2; $YDIS/$PART" | bc`

if [ `echo "$XDIS/$XINC" | bc` -ge 250 ]; then
  XINC2=$XINC
  YINC2=$YINC
else
  XINC2=`echo "scale=2; $XDIS/250" | bc`
  YINC2=$XINC2
fi

TITLE1=`printf "log@-10@- @~F@~@-%d%d@-\n" $IQNT $IQNT`
TITLE2="$PLOT m (Time $TMST-$TMED)"
XLEN=12
YLEN=`echo "scale=2; $XLEN*$YDIS/$XDIS" | bc`
YPOS=`echo "scale=2; $YLEN+0.3" | bc`

gmtset ANNOT_FONT_SIZE  12p
gmtset LABEL_FONT_SIZE  12p
gmtset LABEL_OFFSET     0.1c
gmtset TICK_LENGTH     -0.2c

### Color palette
CMIN=`echo "scale=5; (-5.0)*$CDEL" | bc`
CMAX=`echo "scale=5;  (5.0)*$CDEL" | bc`
makecpt -Cno_green -T$CMIN/$CMAX/$CDEL > $F_OUT.cpt

### Wind velocity
surface $F_OUT.dvc -H4 -T0.25 -R-$XDIS/$XDIS/-$YDIS/$YDIS -I$XINC2/$YINC2 -G$F_OUT.grd
grdimage $F_OUT.grd -C$F_OUT.cpt -JX$XLEN/$YLEN -P -X3.0 -Y4.0 -K > $F_OUT.ps

### Base map
psbasemap -JX -R -Ba10f1:"$XLAB":/a10f1:"$YLAB":WeSn -K -O >> $F_OUT.ps

### Title & Color scale
echo 0.5 $YPOS 14 0 0 LB "$TITLE1" | \
pstext -JX -R0/$XLEN/0/$YLEN -N -K -O >> $F_OUT.ps
echo 5.0 $YPOS 12 0 0 LB "$TITLE2" | \
pstext -JX -R -N -K -O >> $F_OUT.ps

XCEN=`echo "scale=2; $XLEN/2.0-0.5" | bc`
XWDT=`echo "scale=2; $XLEN/1.5" | bc`
psscale -C$F_OUT.cpt -D$XCEN/-1.5/$XWDT/0.3h -E1.0 -O >> $F_OUT.ps

rm -f $F_OUT.dvc
rm -f $F_OUT.cpt
rm -f $F_OUT.grd

if [ -n "$VIEW" ]; then
  kghostview $F_OUT.ps
fi
