#!/bin/sh

. ../GetYesNo.sh

CDEL=0.001
IQNT=2

. ./GetOpts

if GetYesNo "### Do you recalculate sdv-data. (y/n) ?"
then
  CALC="TRUE"
else
  CALC=""
fi

if GetYesNo "### Do you normalize sdv-data by u_*. (y/n) ?"
then
  UNIT=""
  echo -n "    u_* (m/s) =? "
  read USTA
else
  UNIT="m@+2@+ s@+-2@+"
  USTA=1.0
fi

F_OUT=test
SDIR=$HOME/les_for_es/pod
GDIR=$DDIR/Movie

cd $DDIR

if [ -n "$CALC" ]; then

$SDIR/pod_sdv << EOF1 > $GDIR/$F_OUT.sdv
&pod1
r_num = $N_IN
irsta = 1
irend = 999
/
&pod3
iqnt   = $IQNT
/
EOF1

fi

cd $GDIR

TMST=`awk 'NR == 1 {print $1}' $F_OUT.sdv`
TMED=`awk 'NR == 1 {print $2}' $F_OUT.sdv`
DX=`awk 'NR == 2 {print $1}' $F_OUT.sdv`
DY=`awk 'NR == 2 {print $2}' $F_OUT.sdv`
DZ=`awk 'NR == 2 {print $3}' $F_OUT.sdv`
XP=`awk 'NR == 3 {print $1}' $F_OUT.sdv`
YP=`awk 'NR == 3 {print $2}' $F_OUT.sdv`
ZT=`awk 'NR == 3 {print $3}' $F_OUT.sdv`
ZP=${ZP:=$ZT}
PLANE=`awk 'NR == 4 {print $1}' $F_OUT.sdv`

  XINC=$DX; YINC=$DZ; XDIS=$XP; YDIS=$ZP
  XLAB="n (= (n@-x@-@+2@+ + n@-y@-@+2@+)@+1/2@+)"; YLAB="z (km)"

YFAC=2

XDIS=`echo "scale=2; $XINC*1.5+30" | bc`
XORG=`echo "scale=2; $XINC*0.5" | bc`

###  m -> km
YDISB=`echo "scale=2; $YDIS/1000" | bc`
###
  XINC2=$XINC
  YINC2=$YINC

TITLE1=`printf "R@+^@+@-%d%d@-\n" $IQNT $IQNT`
TITLE2="Time  $TMST-$TMED"
XLEN=12
YLEN=6
# YLEN=`echo "scale=2; $XLEN*$YFAC*$YDIS/8000" | bc`
YPOS=`echo "scale=2; $YLEN+0.3" | bc`

if [ `echo $YDIS | cut -d'.' -f1` -lt 2000 ]; then
  YTICK="a0.5f0.1"
else
  YTICK="a1f0.1"
fi

gmtset ANNOT_FONT_SIZE  12p
gmtset LABEL_FONT_SIZE  12p
gmtset LABEL_OFFSET     0.1c
gmtset TICK_LENGTH     -0.2c

### Color palette
CMAX=`echo "scale=5;  (6.0)*$CDEL" | bc`
CMIN=$CDEL
if [ -n "$COLOR" ]; then
  makecpt -Cno_green -T$CMIN/$CMAX/$CDEL | egrep -v "^B|^F|^N" > $F_OUT.cpt
  echo "B	255	255	255" >> $F_OUT.cpt
  echo "F	255	0	0"   >> $F_OUT.cpt
  echo "N	255	255	255" >> $F_OUT.cpt
else
  makecpt -Cgray -T0.0/$CMAX/$CDEL -I | awk '$1!=0 && $1!="N" {print}' > $F_OUT.cpt
  echo "N	255	255	255" >> $F_OUT.cpt
fi

### Wind velocity
# awk 'NR > 4 {print $1, $2, $3}' $F_OUT.sdv | \
# surface -T0.0 -R$XORG/$XDIS/0/$YDIS -I$XINC2/$YINC2 -G$F_OUT.grd
awk -v ust=$USTA 'NR > 4 && $3 > 0.0 {print $1, $2, $3/ust^2}' $F_OUT.sdv | \
xyz2grd -F -R$XORG/$XDIS/0/$YDIS -I$XINC2/$YINC2 -G$F_OUT.grd
grdimage $F_OUT.grd -C$F_OUT.cpt -JX$XLEN/$YLEN -P -X3.0 -Y4.0 -K > $F_OUT.ps

### Base map
psbasemap -JX -R$XORG/$XDIS/0/$YDISB -Ba5f1:"$XLAB":/"$YTICK":"$YLAB":WeSn -K -O >> $F_OUT.ps

### Title & Color scale
echo 0.5 $YPOS 14 0 0 LB "$TITLE1" | \
pstext -JX -R0/$XLEN/0/$YLEN -N -K -O >> $F_OUT.ps
echo 5.0 $YPOS 12 0 0 LB "$TITLE2" | \
pstext -JX -R -N -K -O >> $F_OUT.ps

XCEN=`echo "scale=2; $XLEN/2.0-0.5" | bc`
XWDT=`echo "scale=2; $XLEN/1.5" | bc`
psscale -C$F_OUT.cpt -D$XCEN/-1.5/$XWDT/0.3h -B/:"$UNIT": -E0.8 -O >> $F_OUT.ps

# rm -f $F_OUT.sdv
rm -f $F_OUT.cpt
rm -f $F_OUT.grd

if [ -n "$VIEW" ]; then
  kghostview $F_OUT.ps
fi
