#!/bin/sh

. ../GetYesNo.sh

JPLANE=2
# CDEL=4.0
CDEL=2.8
FACT=100.0
WSPD=0.015
PART=5

. ./GetOpts

# if GetYesNo "### Do you plot contours of pot.temp. (y/n) ?"
# then
#   POTC="TRUE"
# else
  POTC=""
# fi
echo -n "### Specify the increment for arrows (default INCR=3). "
read INCR
INCR=${INCR:=3}

F_OUT=test
SDIR=$PWD
GDIR=$DDIR/Movie

cd $DDIR

F_NAME="pav_"$N_IN
$SDIR/bin2txt << EOF1 > $GDIR/$F_OUT.dvc
&figs
f_name = $F_NAME
irec   = $IREC
jplane = $JPLANE
inc    = 1
ival   = 1
/
EOF1

F_NAME="pau_"$N_IN
$SDIR/bin2txt << EOF3 > $GDIR/$F_OUT.duc
&figs
f_name = $F_NAME
irec   = $IREC
jplane = $JPLANE
inc    = 1
ival   = 1
/
EOF3

F_NAME="paw_"$N_IN
$SDIR/bin2txt << EOF4 > $GDIR/$F_OUT.dwc
&figs
f_name = $F_NAME
irec   = $IREC
jplane = $JPLANE
inc    = 1
ival   = 1
/
EOF4

KX=`awk -v irec=$IREC '$1 == irec {print $2}' "pak_"$N_IN`
KY=`awk -v irec=$IREC '$1 == irec {print $3}' "pak_"$N_IN`
if [ $KX -ne 0 ]; then
  AG=`echo "scale=5; a($KY/$KX)*180.0/3.141593" | bc -l`
else
  exit 1
fi
ANGL=${ANGL:=$AG}
echo "angle = $ANGL"

if [ -n "$POTC" ]; then
  JREC=`awk -v irec=$IREC '$1 == irec {print $5}' "pak_"$N_IN`
  { echo "t___"; echo $N_IN; echo $JREC $KX $KY $JPLANE $ANGL; } | \
  $SDIR/../pod/pod_dcmp > $GDIR/$F_OUT.dtc
fi

cd $GDIR

TIME=`awk 'NR == 1 {print $1}' $F_OUT.dvc`
DX=`awk 'NR == 2 {print $1}' $F_OUT.dvc`
DY=`awk 'NR == 2 {print $2}' $F_OUT.dvc`
DZ=`awk 'NR == 2 {print $3}' $F_OUT.dvc`
XP=`awk 'NR == 3 {print $1}' $F_OUT.dvc`
YP=`awk 'NR == 3 {print $2}' $F_OUT.dvc`
ZT=`awk 'NR == 3 {print $3}' $F_OUT.dvc`
ZP=${ZP:=$ZT}
PLANE=`awk 'NR == 4 {print $1}' $F_OUT.dvc`

. $SDIR/SetAxes

YFAC=1
XLAB="H (km)"

if   [ "$PLANE" = "y-z" ]; then
  WIND="u@-cross@- and (u@-along@-, w)"
elif [ "$PLANE" = "x-z" ]; then
  WIND="u@-along@- and (u@-cross@-, w)"
else
  WIND="w and (u, v)"
fi

XDIS=`echo "scale=2; $XDIS/$PART" | bc`
# XDIS=`awk -v ang=$ANGL -v dis=$XDIS 'BEGIN {c=cos(ang*3.141593/180.0); if(c>0.5) c=0.5; print dis*c}'`

###  m -> km
XDISB=`echo "scale=2; $XDIS/1000" | bc`
YDISB=`echo "scale=2; $YDIS/1000" | bc`
###
if [ `echo "$XDIS/$XINC" | bc` -ge 500 ]; then
  XINC2=$XINC
  YINC2=$YINC
else
  XINC2=`echo "scale=2; $XDIS/500" | bc`
  YINC2=$XINC2
fi

TITLE1="$WIND"
TITLE2=`printf "(%3d,%3d)\n" $KX $KY`
XLEN=12
YLEN=`echo "scale=2; $XLEN*$YFAC*$YDIS/$XDIS" | bc`
YPOS=`echo "scale=2; $YLEN+0.3" | bc`

VFAC=`echo "scale=5; 0.5/$WSPD" | bc`
WPAR=0.03/0.21/0.07n0.14

FPWR=`echo "scale=0; l($FACT)/l(10.0)*(-1)" | bc -l`
UNIT=`printf "10@+%d@+ m s@+-1@+" $FPWR`

if [ "$ANGL" != "0" ]; then
  paste $F_OUT.duc $F_OUT.dvc | \
  awk '{print $1, 0, $2, $3, $8}' | \
  awk -v ang=$ANGL -v dis=$XDIS -f $SDIR/uvrot.awk > $F_OUT.dmy
  paste $F_OUT.dmy $F_OUT.duc | \
  awk '{print $1, $2, $3, $4, $5, $9, $10}' > $F_OUT.dat

  awk '{print $1, $3, $4, $6, $7}' $F_OUT.dat > $F_OUT.duc
  awk '{print $1, $3, $5, $6, $7}' $F_OUT.dat > $F_OUT.dvc
fi

gmtset ANNOT_FONT_SIZE  12p
gmtset LABEL_FONT_SIZE  12p
gmtset LABEL_OFFSET     0.1c
gmtset TICK_LENGTH     -0.2c

### Color palette
if [ -n "$COLOR" ]; then
  CMIN=`echo "scale=5; (-5.0)*$CDEL" | bc`
  CMAX=`echo "scale=5;  (5.0)*$CDEL" | bc`
  makecpt -Cno_green -T$CMIN/$CMAX/$CDEL > $F_OUT.cpt
else
# CMIN=`echo "scale=5; (-6.0)*$CDEL" | bc`
# CMAX=`echo "scale=5;  (4.0)*$CDEL" | bc`
# makecpt -Cgray -T$CMIN/$CMAX/$CDEL | \
# awk 'NR!=4 && NR!=5 && $1!="B" {print}' > $F_OUT.cpt
# echo "B	38	38	38" >> $F_OUT.cpt
  CMIN=`echo "scale=5; (-4.0)*$CDEL" | bc`
  CMAX=`echo "scale=5;  (3.0)*$CDEL" | bc`
  makecpt -Cgray -T$CMIN/$CMAX/$CDEL | \
  awk 'NR!=4 && $1!="B" {print}' > $F_OUT.cpt
  echo "B	24	24	24" >> $F_OUT.cpt
fi

### Wind velocity
awk -v fact=$FACT 'NR > 4 {print $1, $2, $3*fact}' $F_OUT.dvc | \
surface -T0.25 -R0/$XDIS/0/$YDIS -I$XINC2/$YINC2 -G$F_OUT.grd
grdimage $F_OUT.grd -C$F_OUT.cpt -JX$XLEN/$YLEN -P -X3.0 -Y4.0 -K > $F_OUT.ps

### Wind vector
paste $F_OUT.duc $F_OUT.dwc | \
awk -v vfac=$VFAC -v inc=$INCR 'NR > 4 {if (($4-2)%inc == 0 && ($5-2)%inc == 0) print $1, $2, $3*vfac, $8*vfac}' | \
awk -f $SDIR/uv2ds.awk | \
psxy -JX -R -SV"$WPAR" -G0/0/0 -K -O >> $F_OUT.ps

if [ -n "$POTC" ]; then
  xyz2grd $F_OUT.dtc -H4 -F -R -I$XINC/$YINC -G$F_OUT.grd
  { echo 0.0 "C"; echo 0.3 "C"; echo 0.6 "C"; } > $F_OUT.dcl
  grdcontour $F_OUT.grd -C$F_OUT.dcl -JX$XLEN/$YLEN -W6/255/255/255 -K -O >> $F_OUT.ps
  { echo -0.3 "C"; echo -0.6 "C"; } > $F_OUT.dcl
  grdcontour $F_OUT.grd -C$F_OUT.dcl -JX$XLEN/$YLEN -W6t25_15:0/255/255/255 -K -O >> $F_OUT.ps
fi

### Base map
psbasemap -JX -R0/$XDISB/0/$YDISB -Ba1f0.1:"$XLAB":/a1f0.1:"$YLAB":WeSn -K -O >> $F_OUT.ps

### Title & Color scale
if [ -n "$LEGN" ]; then
  echo 9.3 `echo "scale=2; $YPOS+0.15" | bc` 90 0.5 | \
  psxy -JX -R0/$XLEN/0/$YLEN -SV"$WPAR" -G0/0/0 -N -K -O >> $F_OUT.ps
  echo 10.0 $YPOS 12 0 0 LB "$WSPD m s@+-1@+" | \
  pstext -JX -R -N -K -O >> $F_OUT.ps

  XCEN=`echo "scale=2; $XLEN/2.0-1.0" | bc`
  XWDT=`echo "scale=2; $XLEN/1.5" | bc`
  psscale -C$F_OUT.cpt -D$XCEN/-1.5/$XWDT/0.3h -B/:"$UNIT": -E0.8 -K -O >> $F_OUT.ps
fi

echo 0.5 $YPOS 14 0 0 LB "$TITLE1" | \
pstext -JX -R0/$XLEN/0/$YLEN -N -K -O >> $F_OUT.ps
echo 7.0 $YPOS 12 0 0 LB "$TITLE2" | \
pstext -JX -R -N -O >> $F_OUT.ps

rm -f $F_OUT.d*
rm -f $F_OUT.cpt
rm -f $F_OUT.grd

if [ -n "$VIEW" ]; then
  kghostview $F_OUT.ps
fi
