#
#  Calculates Richardson number
#
{
  u[NR] = $1;
  v[NR] = $3;
  t[NR] = $5;
  z[NR] = $2;
}

END {
  gpt  = 9.81/300.0;

  for ( k = 2; k <= NR; k++ ) {
    zz = 0.5*( z[k]+z[k-1] );
    dz =       z[k]-z[k-1];
    dt =       t[k]-t[k-1];
    du =     ( u[k]-u[k-1] )^2 + ( v[k]-v[k-1] )^2 + 1.0e-10;
    ri = gpt * dz * dt / du;

    print ri, zz/1000.0;
  }
}
