#
#  Rotates the coordinate axis
#
#  ang and dis are specified through '-v ang=$ANG -v dis=$DIS'
#  usually, -90 < ang < 90
#
#  ($1, $2, $3, $4, $5) = (x, y, z, u, v)
#
{
  d2r = 3.141593/180.0;
  cs  = cos( ang*d2r );
  sn  = sin( ang*d2r );

  x   =  $1 * cs + $2 * sn;
  y   = -$1 * sn + $2 * cs;
  u   =  $4 * cs + $5 * sn;
  v   = -$4 * sn + $5 * cs;

  if ( ang > 90.0 || ang < -90.0 ) {
    x =  x + dis;
    y =  y + dis;
  }

  print x, y, $3, u, v;
}
