#!/bin/sh

TERM=("uu" "vv" "ww" "tke"  "uw" "vw" "uv" "X")
NAME=("<u@+2@+>" "<v@+2@+>" "<w@+2@+>" "TKE"  "<uw>" "<vw>" "<uv>" "X")
LINE=("W8" "W8t25_15:0" "W8t10_15:0" "W2 -Sc0.12"  "W8" "W8t25_15:0" "W8t10_15:0" "")
NSUM=`expr ${#TERM[@]} / 2 - 1`
MSUM=$NSUM

FLBL=("(a)" "(b)")

XE=6

. ./GetOpts

if [ $XE -le 0 ]; then
  echo "XE = $XE must be positive !"
  exit 9
fi

F_OUT=test
SDIR=$HOME/les_for_es/post
GDIR=$DDIR/Movie

cd $DDIR

$SDIR/varflx << EOF1 > $GDIR/$F_OUT.dat
&post
r_num  = $N_IN
irec   = $IREC
ziin   = $ZIIN
/
EOF1

cd $GDIR

TIME=`awk 'NR == 1 {print $1}' $F_OUT.dat`
DZ=`awk 'NR == 2 {print $1}' $F_OUT.dat`
ZT=`awk 'NR == 3 {print $1}' $F_OUT.dat`
ZP=`echo "scale=2; ${ZP:=$ZT}/1000.0" | bc`

XLEN=6
YLEN=8
if [ "$FACT" != "1.0" ]; then
  XADD=`printf " (x10@+%d@+)" $FPWR`
fi
XLAB=("Normalized variances" "Normalized fluxes")
YLAB="Height (km)"

if [ $XE -le 1 ]; then
  XTICK="a0.2f0.1"
else
  XTICK="a2f1"
fi

gmtset ANNOT_FONT_SIZE  12p
gmtset LABEL_FONT_SIZE  12p
gmtset LABEL_OFFSET     0.15c
gmtset TICK_LENGTH     -0.2c

for M in 0 1
do

### Base map
if [ $M -eq 0 ]; then
  XSTA=0
  XEND=$XE
# XPOS=3.6
  XPOS=2.0

  psbasemap -JX$XLEN/$YLEN -R$XSTA/$XEND/0/$ZP -B"$XTICK":"${XLAB[$M]}$XADD":/a0.5f0.1:"$YLAB":WeSn -P -X3.0 -Y4.0 -K > $F_OUT.ps
else
  XSTA=-1
  XEND=0.5
# XEND=1
  XPOS=1.6

  psbasemap -JX$XLEN/$YLEN -R$XSTA/$XEND/0/$ZP -Ba0.5f0.1:"${XLAB[$M]}$XADD":/a0.5f0.1WeSn -X7.2 -K -O >> $F_OUT.ps
  { echo 0 0; echo 0 $ZP; } | \
  psxy -JX -R -W2 -K -O >> $F_OUT.ps
fi

XPLS=`echo "scale=2; $XPOS-1.0" | bc`
XPLE=`echo "scale=2; $XPOS-0.2" | bc`
XPLM=`echo "scale=2; $XPOS-0.6" | bc`

for N in `seq 0 $NSUM`
do
  MN=`expr $N + $M \* \( $MSUM + 1 \)`
  if [ "${TERM[$MN]}" = "X" ]; then
    continue
  fi

  YPOS=`echo "scale=2; $YLEN-1.7-$N*0.5" | bc`
  YPLS=$YPOS

### Profile
  awk -v term=${TERM[$MN]} -v fact=$FACT 'NR > 4 && $1==term {print $2*fact, $3/1000.0}' $F_OUT.dat | \
  psxy -JX -R$XSTA/$XEND/0/$ZP -${LINE[$MN]} -K -O >> $F_OUT.ps

#####
  awk -v term=${TERM[$MN]} -v fact=$FACT 'NR > 4 && $1==term {print $2*fact, $3/1000.0}' $F_OUT.dat | \
  awk -f $SDIR/../gmt/maxmin.awk > $F_OUT.dmax
  DMAX=`awk '{print $1}' $F_OUT.dmax`; DMAX=`printf "%.3f" $DMAX`
  DHGT=`awk '{print $2}' $F_OUT.dmax`
# if [ `echo $DMAX | cut -d'.' -f1` -ge $XEND ]; then
#   XPO2=`echo "scale=2; $XLEN-0.9" | bc`
#   echo $XPO2 $DHGT 90 0.7 | \
#   psxy -JX -R0/$XLEN/0/$ZP -SV0.03/0.21/0.07 -G0/0/0 -K -O >> $F_OUT.ps
#   echo $XPO2 $DHGT 12 0 0 RM $DMAX | \
#   pstext -JX -R -W255/255/255 -C0.05 -K -O >> $F_OUT.ps
# fi
#####

### Legend
  echo $XPOS $YPOS 12 0 0 LM "${NAME[$MN]}" | \
  pstext -JX -R0/$XLEN/0/$YLEN -K -O >> $F_OUT.ps

  { echo $XPLS $YPLS; echo $XPLM $YPLS; echo $XPLE $YPLS; } | \
  psxy -JX -R -${LINE[$MN]} -K -O >> $F_OUT.ps
done

XPO2=`echo "scale=2; $XLEN-0.6" | bc`
YPO2=`echo "scale=2; $YLEN-0.9" | bc`
  echo $XPO2 $YPO2 14 0 0 RM "${FLBL[$M]}" | \
  pstext -JX -R -W255/255/255 -C0.1 -K -O >> $F_OUT.ps
if [ $M -ne 1 ]; then
  echo 1.0 $YPO2 12 0 0 LM "Time  $TIME" | \
  pstext -JX -R -W255/255/255 -C0.1 -K -O >> $F_OUT.ps
else
  echo 0.6 $YPO2 12 0 0 LM "Time  $TIME" | \
  pstext -JX -R -W255/255/255 -C0.1 -O >> $F_OUT.ps
fi

done

rm -f $F_OUT.dat

if [ -n "$VIEW" ]; then
  kghostview $F_OUT.ps
fi
