#!/bin/sh

. ./Xtick.sh

. ./GetOpts

F_OUT=test
SDIR=$PWD
GDIR=$DDIR/Movie

cd $DDIR

if [ "$Q_IN" = "th__" ]; then
  F_NAME="t___"${N_IN}
else
  F_NAME=${Q_IN}${N_IN}
fi
$SDIR/bin2prf << EOF1 > $GDIR/$F_OUT.dat
&figs
f_name = "$F_NAME"
irec   =  $IREC
/
EOF1

cd $GDIR

TIME=`awk 'NR == 1 {print $1}' $F_OUT.dat`
DZ=`awk 'NR == 2 {print $1}' $F_OUT.dat`
ZT=`awk 'NR == 3 {print $1}' $F_OUT.dat`
ZP=`echo "scale=2; ${ZP:=$ZT}/1000.0" | bc`

XLEN=6
YLEN=8
YLAB="Height (km)"
XLAB=`awk -v qnt=$Q_IN 'BEGIN {FS=","} $2==qnt {print $3}' $SDIR/vprof.par`
FACT=`awk -v qnt=$Q_IN 'BEGIN {FS=","} $2==qnt {print $4}' $SDIR/vprof.par`

xtick "$F_OUT.dat"

YPOS=`echo "scale=2; $YLEN-0.9" | bc`
if [ "$Q_IN" = "q___" -o "$Q_IN" = "zwt_" ]; then
  XPOS=`echo "scale=2; $XLEN-2.4" | bc`
else
  XPOS=0.6
fi

gmtset ANNOT_FONT_SIZE  12p
gmtset LABEL_FONT_SIZE  12p
gmtset LABEL_OFFSET     0.15c
gmtset TICK_LENGTH     -0.2c

### Base map
psbasemap -JX$XLEN/$YLEN -R$XS/$XE/0/$ZP -B"$XTICK":"$XLAB":/a0.5f0.1:"$YLAB":WeSn -P -X3.0 -Y4.0 -K > $F_OUT.ps
if [ `echo $Q_IN | cut -c-2` = "zw" -a \( $XS -lt 0 -a $XE -gt 0 \) ]; then
  { echo 0 0; echo 0 $ZP; } | \
  psxy -JX -R -W2 -K -O >> $F_OUT.ps
fi

### Profile
awk -v fact=$FACT 'NR > 4 {print $1*fact, $2/1000.0}' $F_OUT.dat | \
psxy -JX -R -W8 -K -O >> $F_OUT.ps

### Legend
echo $XPOS $YPOS 12 0 0 LM "Time  $TIME" | \
pstext -JX -R0/$XLEN/0/$YLEN -O >> $F_OUT.ps

rm -f $F_OUT.dat

if [ -n "$VIEW" ]; then
  kghostview $F_OUT.ps
fi
