#!/bin/sh

. ./Xtick.sh

# IREC=(1 3)
# LINE=("W8t20_10:0/32/96/255" "W8/255/112/0")
# F_NAME="/home/naka/les_for_es/obs/WNG.OBS"
# IREC=1
# LINE="W8t20_10:0/32/96/255"
# F_NAME="/home/naka/les_for_es/obs/GCSS.OBS"
IREC=(1 2 3 4)
LINE=("W8/255/64/64" "W8t25_15:0/192/64/255" "W8t10_15:0/128/32/255" "W8t30_10_10_10:0/0/0/128")
F_NAME="/home/naka/les_for_es/obs/WNGN.OBS"

NSUM=`expr ${#IREC[@]} - 1`

TITLE="(a)  Wangara"

Q_IN="th__"

. ./GetOpts

case $Q_IN in
  "u___" | "v___" | "th__" | "qv__" | "ws__") ;;
   * ) echo "Quantity = $Q_IN is invalid !"; exit 2 ;;
esac

F_OUT=test
SDIR=$PWD
GDIR=$DDIR/Movie

cd $DDIR

for N in `seq 0 $NSUM`
do
$SDIR/obs2prf << EOF1 > $GDIR/$F_OUT.dat$N
&figs
f_name = "$F_NAME"
irec   =  ${IREC[$N]}
iqnt   =  $Q_IN
/
EOF1
done

cd $GDIR

ZT=`awk 'NR == 3 {print $1}' $F_OUT.dat0`
ZP=`echo "scale=2; ${ZP:=$ZT}/1000.0" | bc`

XLEN=6
YLEN=8
YLAB="Height (km)"
XLAB=`awk -v qnt=$Q_IN 'BEGIN {FS=","} $2==qnt {print $3}' $SDIR/vprof.par`
FACT=`awk -v qnt=$Q_IN 'BEGIN {FS=","} $2==qnt {print $4}' $SDIR/vprof.par`

xtick "$F_OUT.dat0"

if [ "$Q_IN" = "qv__" -o "$Q_IN" = "ws__" ]; then
  XPOS=`echo "scale=2; $XLEN-1.4" | bc`
else
  XPOS=1.6
fi
  YPOS=`echo "scale=2; $YLEN+0.4" | bc`

XPLS=`echo "scale=2; $XPOS-1.0" | bc`
XPLE=`echo "scale=2; $XPOS-0.2" | bc`

gmtset ANNOT_FONT_SIZE  12p
gmtset LABEL_FONT_SIZE  12p
gmtset LABEL_OFFSET     0.1c
gmtset TICK_LENGTH     -0.2c

### Base map
psbasemap -JX$XLEN/$YLEN -R$XS/$XE/0/$ZP -B"$XTICK":"$XLAB":/a0.5f0.1:"$YLAB":WeSn -P -X3.0 -Y4.0 -K > $F_OUT.ps

if [ -n "$TITLE" ]; then
  echo 0.4 $YPOS 14 0 0 LB "$TITLE" | \
  pstext -JX -R0/$XLEN/0/$YLEN -N -K -O >> $F_OUT.ps
fi

for N in `seq 0 $NSUM`
do
  TIME=`awk 'NR == 1 {print $1}' $F_OUT.dat$N`

  YPOS=`echo "scale=2; $YLEN-0.9-$N*0.5" | bc`
  YPLS=$YPOS

### Profile
  awk -v fact=$FACT 'NR > 4 {print $1*fact, $2/1000.0}' $F_OUT.dat$N | \
  psxy -JX -R$XS/$XE/0/$ZP -${LINE[$N]} -K -O >> $F_OUT.ps

### Legend
  echo $XPOS $YPOS 12 0 0 LM "$TIME" | \
  pstext -JX -R0/$XLEN/0/$YLEN -K -O >> $F_OUT.ps

  if [ $N -lt $NSUM ]; then
    { echo $XPLS $YPLS; echo $XPLE $YPLS; } | \
    psxy -JX -R -${LINE[$N]} -K -O >> $F_OUT.ps
  else
    { echo $XPLS $YPLS; echo $XPLE $YPLS; } | \
    psxy -JX -R -${LINE[$N]} -O >> $F_OUT.ps
  fi
done

rm -f $F_OUT.dat*

kghostview $F_OUT.ps
