#!/bin/sh

DDIR=/work2/typh
N_IN=("21.99" "22.99")
WIDTH=("W10" "W5")
MSUM=`expr ${#N_IN[@]} - 1`

TERM=("tke" "ust")
NAME=("TKE" "u@-*@-")
ZFAC=(0.01 1)
UNIT=(" (10@+2@+ m@+3@+ s@+-2@+)" " (m s@+-1@+)")
ZSTA=(24 1.3)
ZEND=(64 1.8)
ZTICK=("a8f8" "a0.1f0.1")
ZWESN=("Wesn" "wEsn")
LINE=("" "t25_15:0")
NSUM=`expr ${#TERM[@]} - 1`

# XS=0.6666667
# XE=4.833333
XS=0.8333333
XE=4.666667

VIEW="TRUE"

F_OUT=test
GDIR=$DDIR/Movie

cd $GDIR

XLEN=8
YLEN=5.5
XLAB="Time (hour)"

XTICK="a1f0.1666667"

# XPOS=1.6
XPOS=`echo "scale=2; $XLEN-1.4" | bc`

XPLS=`echo "scale=2; $XPOS-1.0" | bc`
XPLE=`echo "scale=2; $XPOS-0.2" | bc`
XPLM=`echo "scale=2; $XPOS-0.6" | bc`

gmtset ANNOT_FONT_SIZE  12p
gmtset LABEL_FONT_SIZE  12p
gmtset LABEL_OFFSET     0.15c
gmtset TICK_LENGTH     -0.2c

### Base map
psbasemap -JX$XLEN/$YLEN -R$XS/$XE/${ZSTA[0]}/${ZEND[0]} -B"$XTICK":"$XLAB":/"${ZTICK[0]}"weSn -P -X3.0 -Y4.0 -K > $F_OUT.ps

for M in `seq 0 $MSUM`
do
  cp -f $DDIR/zius${N_IN[$M]} $GDIR/$F_OUT.dat

for N in `seq 0 $NSUM`
do
#   YPOS=`echo "scale=2; $YLEN-0.6-$N*0.5" | bc`
  YPOS=`echo "scale=2; 1.1-$N*0.5" | bc`
  YPLS=$YPOS

### Profile
  awk -v term=${TERM[$N]} -v fact=${ZFAC[$N]} '$1==term {print $2+$3/60.0, $4*fact}' $F_OUT.dat | \
  psxy -JX -R$XS/$XE/${ZSTA[$N]}/${ZEND[$N]} -${WIDTH[$M]}${LINE[$N]} -B/"${ZTICK[$N]}":"${NAME[$N]}${UNIT[$N]}":"${ZWESN[$N]}" -K -O >> $F_OUT.ps

### Legend
if [ $M -eq $MSUM ]; then
  echo $XPOS $YPOS 12 0 0 LM "${NAME[$N]}" | \
  pstext -JX -R0/$XLEN/0/$YLEN -K -O >> $F_OUT.ps

  if [ $N -lt $NSUM ]; then
    { echo $XPLS $YPLS; echo $XPLM $YPLS; echo $XPLE $YPLS; } | \
    psxy -JX -R -${WIDTH[0]}${LINE[$N]} -K -O >> $F_OUT.ps
  else
    { echo $XPLS $YPLS; echo $XPLM $YPLS; echo $XPLE $YPLS; } | \
    psxy -JX -R -${WIDTH[0]}${LINE[$N]} -O >> $F_OUT.ps
  fi
fi
done
done

rm -f $F_OUT.dat

if [ -n "$VIEW" ]; then
  kghostview $F_OUT.ps
fi
