c **********************************************************************
c *   Making a file of the observational data                          *
c *                                                                    *
c *   Data stored in the file 'OBS':                                   *
c *     nzob          : Number of observational levels                 *
c *     tref          : Reference 'potential' temperature     (deg.C)  *
c *     tsf           : Temperature at the ground surface     (deg.C)  *
c *     psf           : Pressure    at the ground surface       (hPa)  *
c *     hob           : Height above ground level                 (m)  *
c *     pob           : Pressure                                (hPa)  *
c *     tob           : Temperature                           (deg.C)  *
c *     qob           : Specific humidity                      (g/kg)  *
c *     uob, vob      : Horizontal velocity components          (m/s)  *
c **********************************************************************
c
      include  "../src/Implicit.h"
c
      parameter ( mob=201 )
      dimension  hob(mob), pob(mob), tob(mob), qob(mob),
     :           uob(mob), vob(mob)
c
      open (12,file='GCSS.OBS',form='unformatted')
c
      nzob = 6
      tref =   30.00d0
      psf  = 1015.00d0
      t00  =  273.15d0
c
      hob(1) =    0.0d0
      hob(2) =  520.0d0
      hob(3) =  700.0d0
      hob(4) = 1480.0d0
      hob(5) = 2000.0d0
      hob(6) = 3000.0d0
c
      tob(1) =  298.70d0 -t00
      tob(2) =  298.70d0 -t00
      tob(3) =  999.9
      tob(4) =  302.40d0 -t00
      tob(5) =  308.20d0 -t00
      tob(6) =  311.85d0 -t00
c
      qob(1) =   17.0d0
      qob(2) =   16.3d0
      qob(3) =  999.9
      qob(4) =   10.7d0
      qob(5) =    4.2d0
      qob(6) =    3.0d0
c
      uob(1) =   -8.75d0
      uob(2) =   -8.75d0
      uob(3) =   -8.75d0
      uob(4) =  999.9
      uob(5) =  999.9
      uob(6) =   -4.61d0
c
      tob(3) = tob(2) +(tob(4)-tob(2))*(hob(3)-hob(2))/(hob(4)-hob(2))
      qob(3) = qob(2) +(qob(4)-qob(2))*(hob(3)-hob(2))/(hob(4)-hob(2))
      uob(4) = uob(3) +(uob(6)-uob(3))*(hob(4)-hob(3))/(hob(6)-hob(3))
      uob(5) = uob(3) +(uob(6)-uob(3))*(hob(5)-hob(3))/(hob(6)-hob(3))
c
      do k = 1,nzob
        pob(k) = 1000.0d0
        vob(k) =    0.0d0
      end do
c
      write(12)  nzob, tref, tsf, psf, 0
      write(12)  ( hob(m),m=1,nzob )
      write(12)  ( pob(m),m=1,nzob )
      write(12)  ( tob(m),m=1,nzob )
      write(12)  ( qob(m),m=1,nzob )
      write(12)  ( uob(m),m=1,nzob )
      write(12)  ( vob(m),m=1,nzob )
c
      close(12)
c
      do k = nzob,1,-1
        write(6,*) 'hob,tob,uob=', hob(k), tob(k), uob(k)
      end do
c
      stop
      end
