c **********************************************************************
c *   Calculation of cross spectrum for POD analysis                   *
c *                                                                    *
c *                                   Apr/2007  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "sub_cross_spec.f"
      include  "../src/fft.f"
      include  "../src/Parameter.h"
c
      include  "Paramodif.h"
c
      parameter ( mc=3, md=mc*(mc+1)/2 )
      double precision  pr(mmx,mmy,mz,mz), pi(mmx,mmy,mz,mz)
      integer           ic(md)/ 1, 1, 1, 2, 2, 3/,
     :                  jc(md)/ 1, 2, 3, 2, 3, 3/
c
      double precision  bi(mmx,mmy,mz),    bj(mmx,mmy,mz)
      double precision  ave(mz,mc)
      double precision  wk2(mmx,mmy), trix(mmx), triy(mmy)
      dimension         ifax(20), ifay(20)
c
      character (len=4) :: f_name(mc), p_name = 'pa11'
      character (len=5) :: r_num
      double precision  dat(mx,mz,my)
      data              f_name/ 'u___', 'v___', 'w___'/
c
      namelist  /pod1/ r_num, irsta, irend, kmax
c
      irsta = 1
      irend = 999
c
      read (5,nml=pod1)
c
      open (10,file='para'//r_num,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop 'Para-file not found.'
c
      read (10,*) lx, lz, ly
      close(10)
c
      if ( lx .ne. mx .or. ly .ne. my .or. lz .ne. mz ) then
        write(6,*) 'mx, my, mz =', mx, my, mz
        write(6,*) 'lx, ly, lz =', lx, ly, lz
        stop 'Grid number is not consistent with Parameter.h!'
      end if
c
      nx2 = ( nx -2 )/mskip
      ny2 = ( ny -2 )/mskip
      nxh = ( nx2-1 )/2 +1
      nyh = ( ny2-1 )/2 +1
c
c   **  Note: Intel compiler option, -assume byterecl, is needed.  **
      lrec = 2*nz*nz * 8
c
      call rfftim ( nx2, trix, ifax )
      call rfftim ( ny2, triy, ifay )
c
      open (41,file='paav'//r_num,form='unformatted')
c
      do m = 1,mc
      do k = 1,mz
        ave(k,m) = 0.0d0
      end do
      end do
c
      do id = 1,md
        m  = ic(id)
        n  = jc(id)
c
        open (11,file=f_name(m)//r_num,form='unformatted',
     :           status='old',iostat=ios)
        if ( ios .ne. 0 ) stop 'error'
c
        do ir = 1,irsta-1
          read (11,end=100)
        end do
  100   continue
c
        if ( m .eq. n ) goto 110
c
        open (12,file=f_name(n)//r_num,form='unformatted',
     :           status='old',iostat=ios)
        if ( ios .ne. 0 ) stop 'error'
c
        do ir = 1,irsta-1
          read (12,end=110)
        end do
  110   continue
c
        write(p_name(3:4),'(2i1)') m, n
c
        open (30+id,file=p_name//r_num,access='direct',recl=lrec)
c
        call coeff ( f_name(m) .eq. 'u___', ax1, bx1 )
        call coeff ( f_name(m) .eq. 'v___', ay1, by1 )
        call coeff ( f_name(m) .eq. 'w___', az1, bz1 )
        call coeff ( f_name(n) .eq. 'u___', ax2, bx2 )
        call coeff ( f_name(n) .eq. 'v___', ay2, by2 )
        call coeff ( f_name(n) .eq. 'w___', az2, bz2 )
c
        do l = 1,nz
        do k = 1,nz
        do j = 1,ny2
        do i = 1,nx2
          pr(i,j,k,l) = 0.0d0
          pi(i,j,k,l) = 0.0d0
        end do
        end do
        end do
        end do
c
        do ir = irsta,irend
            read (11,end=200) dat
c
            do k = 1,nz
              do j = 1+mskip,ny-1,mskip
              do i = 1+mskip,nx-1,mskip
                im1 = (i-1)/mskip
                jm1 = (j-1)/mskip
c
                bi(im1,jm1,k) = ax1         * dat(i+1,k  ,j  )
     :                        +     ay1     * dat(i  ,k  ,j+1)
     :                        +         az1 * dat(i  ,k+1,j  )
     :                        + bx1*by1*bz1 * dat(i  ,k  ,j  )
              end do
              end do
c
              call rfftfm( nx2,1,mmx,ny2, bi(1,1,k), trix,ifax, wk2 )
              call rfftfm( ny2,mmx,1,nx2, bi(1,1,k), triy,ifay, wk2 )
            end do
c
          if ( m .eq. n ) then
            do k = 1,nz
              ave(k,m) = ave(k,m) + bi(1,1,k)
c
            do j = 1,ny2
            do i = 1,nx2
              bj(i,j,k) = bi(i,j,k)
            end do
            end do
            end do
c
          else
            read (12,end=200) dat
c
            do k = 1,nz
              do j = 1+mskip,ny-1,mskip
              do i = 1+mskip,nx-1,mskip
                im1 = (i-1)/mskip
                jm1 = (j-1)/mskip
c
                bj(im1,jm1,k) = ax2         * dat(i+1,k  ,j  )
     :                        +     ay2     * dat(i  ,k  ,j+1)
     :                        +         az2 * dat(i  ,k+1,j  )
     :                        + bx2*by2*bz2 * dat(i  ,k  ,j  )
              end do
              end do
c
              call rfftfm( nx2,1,mmx,ny2, bj(1,1,k), trix,ifax, wk2 )
              call rfftfm( ny2,mmx,1,nx2, bj(1,1,k), triy,ifay, wk2 )
            end do
          end if
c
          ntime = ir -irsta +1
c
          call sub_cross_spec( bi,bj, mmx,mmy,mz, nx2,ny2,nz, pr,pi )
c
        end do
c
  200   write(6,'(a,7h count:,i4)') p_name, ntime
c
        do l = 1,nz
        do k = 1,nz
        do j = 1,ny2
        do i = 1,nx2
          pr(i,j,k,l) = pr(i,j,k,l) / dble(ntime)
          pi(i,j,k,l) = pi(i,j,k,l) / dble(ntime)
        end do
        end do
        end do
        end do
c
        do j = 1,nyh
        do i = 1,nx2
          irec = i + nx2*( j-1 )
c
          write(30+id,rec=irec)
     :         ( ( pr(i,j,k,l),pi(i,j,k,l),k=1,nz ),l=1,nz )
        end do
        end do
c
        close(11)
        close(12)
        close(30+id)
      end do
c
      write(41) ( ( ave(k,m)/dble(ntime),k=1,nz ),m=1,mc )
c
      stop
      end
c
      subroutine  coeff ( agree, aa, bb )
c
      logical  agree
c
                   aa = 0.0
      if ( agree ) aa = 0.5
                   bb = 1.0 -aa
c
      return
      end
