c **********************************************************************
c *   Calculation of eigenvalues for POD analysis                      *
c *                                                                    *
c *                                   Apr/2007  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "sub_eigen.f"
      include  "../src/Parameter.h"
c
      include  "Paramodif.h"
c
      parameter ( mc=3, md=mc*(mc+1)/2 )
      double precision  pr(mz,mz,md), pi(mz,mz,md)
      integer           ic(md)/ 1, 1, 1, 2, 2, 3/,
     :                  jc(md)/ 1, 2, 3, 2, 3, 3/
c
      double precision  eval(mz*mc),       we2(mz*mc*mz*mc*4)
      double complex    efun(mz*mc,mz*mc), we1(mz*mc*mz*mc)
      integer                              iwe(mz*mc*5)
c
      character (len=4) :: p_name = 'pa11'
      character (len=5) :: r_num
c
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, phour, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
c
      namelist  /pod1/ r_num, irsta, irend, kmax
c
      kmax = 999
c
      read (5,nml=pod1)
c
      open (10,file='para'//r_num,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop 'Para-file not found.'
c
      read (10,*) lx, lz, ly
c
      if ( lx .ne. mx .or. ly .ne. my .or. lz .ne. mz ) then
        write(6,*) 'mx, my, mz =', mx, my, mz
        write(6,*) 'lx, ly, lz =', lx, ly, lz
        stop 'Grid number is not consistent with Parameter.h!'
      end if
c
      read (10,nml=les2)
      close(10)
c
      nx2 = ( nx -2 )/mskip
      ny2 = ( ny -2 )/mskip
      nxh = ( nx2-1 )/2 +1
      nyh = ( ny2-1 )/2 +1
c
c   **  Note: Intel compiler option, -assume byterecl, is needed.  **
      lrec = 2*nz*nz * 8
c
      kmax = min( kmax, nz )
      nzc  = kmax*mc
c
      do id = 1,md
        write(p_name(3:4),'(2i1)') ic(id), jc(id)
c
        open (30+id,file=p_name//r_num,access='direct',recl=lrec)
      end do
c
        open (41,file='paev'//r_num,form='unformatted',
     :           status='new',iostat=ios)
        if ( ios .ne. 0 ) stop 'paev-file has already existed.'
c
      do j = 1,nyh
      do i = 1,nx2
        irec = i + nx2*( j-1 )
c
        do id = 1,md
          read (30+id,rec=irec) ((pr(k,l,id),pi(k,l,id),k=1,nz),l=1,nz)
        end do
c
        call sub_eigen( 0, pr, pi, mz, kmax, dz, ic, jc, mc, md,
     :                  eval, efun, we1, we2, iwe )
c
c   **  Prints out the eigenvalues in order of size  **
        if ( i-nxh .eq. 0 )
     :  write(6,991) i-nxh, j-nyh,      ( eval(m),m=nzc,nzc-2,-1 )
        write(41)    i-nxh, j-nyh, nzc, ( eval(m),m=nzc,1,-1     )
c
      end do
      end do
c
      stop
  991 format('Eigenvalue at (',i4,',',i4,') =',3(1pe10.2))
      end
