c **********************************************************************
c *   List of eigenvalues calculated from Program pod_2.f              *
c *                                                                    *
c *                                   Apr/2007  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "../src/Parameter.h"
      include  "Paramodif.h"
c
      parameter ( mc=3, md=mc*(mc+1)/2, mm=5, ke=10000 )
      double precision  eval(mz*mc), esum, psum
c
      character (len=5) :: r_num
      dimension         emax(mmx*mmy*mm), imax(mmx*mmy*mm)
c
      namelist  /pod1/ r_num, irsta, irend, kmax
c
      kmax = 999
c
      read (5,nml=pod1)
c
      open (10,file='para'//r_num,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop 'Para-file not found.'
c
      read (10,*) lx, lz, ly
      close(10)
c
      if ( lx .ne. mx .or. ly .ne. my .or. lz .ne. mz ) then
        write(6,*) 'mx, my, mz =', mx, my, mz
        write(6,*) 'lx, ly, lz =', lx, ly, lz
        stop 'Grid number is not consistent with Parameter.h!'
      end if
c
      open (41,file='paev'//r_num,form='unformatted',status='old')
c
      nx2 = ( nx -2 )/mskip
      ny2 = ( ny -2 )/mskip
      nxh = ( nx2-1 )/2 +1
      nyh = ( ny2-1 )/2 +1
c
      kmax = min( kmax, nz )
      nzc  = kmax*mc
c
      nrec = nx2*(nyh-1) + nxh-1
c
      esum = 0.0d0
      psum = 0.0d0
c
      do ij = 1,nrec
        read (41) kxm, kym, nzb, ( eval(m),m=1,nzb )
        if ( nzb .ne. nzc ) stop 'kmax error'
c
        if ( kxm .eq. 0 .and. kym .eq. 0 ) cycle
c
        do m = 1,mm
          emax((ij-1)*mm+m) = eval(m)
          imax((ij-1)*mm+m) = m*ke**2 + (kxm+nxh)*ke + kym+nyh
        end do
c
        do m = 1,nzc
          esum = esum + eval(m)
        end do
      end do
c
      call esort ( emax, imax, nrec*mm )
c
        write(6,*) 'esum =', esum
c
      do k = 1,100
        psum = psum + emax(k)/esum
c
        write(6,992) k, emax(k), emax(k)/esum, psum,
     :             -(mod(imax(k),ke**2)/ke-nxh),
     :             -(mod(imax(k),ke)      -nyh), imax(k)/ke**2
      end do
c
      stop
  992 format('No.=',i4,1pe10.2,2pf6.2,'%',f7.2,
     :       '%  at (',i3,',',i3,';',i2,')')
      end
c
      subroutine  esort ( emax, imax, n )
c
      dimension  emax(n), imax(n)
c
      do i = 1,n-1
        do j = i+1,n
          if ( emax(i) .lt. emax(j) ) then
            ee      = emax(i)
            emax(i) = emax(j)
            emax(j) = ee
            ii      = imax(i)
            imax(i) = imax(j)
            imax(j) = ii
          end if
        end do
      end do
c
      return
      end
