c **********************************************************************
c *   List of power spectrum at a specified height                     *
c *                                                                    *
c *                                   Apr/2011  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "../src/Parameter.h"
      include  "Paramodif.h"
c
      parameter ( mc=3, ke=10000 )
      double precision  pr(mz,mz), pi(mz,mz)
c
      character (len=4)  :: p_name = 'pa11'
      character (len=5)  :: r_num
      dimension         emax(mmx*mmy), imax(mmx*mmy)
c
      namelist  /pod1/ r_num, irsta, irend, kmax
      namelist  /pod3/ iqnt, kplane
c
      iqnt   = 2
      kpalne = 3
c
      read (5,nml=pod1)
      read (5,nml=pod3)
c
      if ( iqnt .lt. 1 .or. iqnt .gt. mc ) stop 'iqnt error'
c
      open (10,file='para'//r_num,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop 'Para-file not found.'
c
      read (10,*) lx, lz, ly
      close(10)
c
      if ( lx .ne. mx .or. ly .ne. my .or. lz .ne. mz ) then
        write(6,*) 'mx, my, mz =', mx, my, mz
        write(6,*) 'lx, ly, lz =', lx, ly, lz
        stop 'Grid number is not consistent with Parameter.h!'
      end if
c
      nx2 = ( nx -2 )/mskip
      ny2 = ( ny -2 )/mskip
      nxh = ( nx2-1 )/2 +1
      nyh = ( ny2-1 )/2 +1
c
c   **  Note: Intel compiler option, -assume byterecl, is needed.  **
      lrec = 2*nz*nz * 8
c
      do id = iqnt,iqnt
        write(p_name(3:4),'(2i1)') id, id
c
        open (30+id,file=p_name//r_num,access='direct',recl=lrec)
      end do
c
      nsum = 0
c
      do j = 1,nyh
      do i = 1,nxh*2-1
        if ( j .eq. nyh .and. i .ge. nxh ) exit
        irec = i + nx2*( j-1 )
c
        do id = iqnt,iqnt
          read (30+id,rec=irec) ((pr(k,l),pi(k,l),k=1,nz),l=1,nz)
        end do
c
        nsum = nsum +1
        emax(nsum) = pr(kplane,kplane)
        imax(nsum) = i*ke + j
      end do
      end do
c
      call esort ( emax, imax, nsum )
c
      do k = 1,100
        write(6,992) k, kplane, emax(k),
     :             -(imax(k)/ke-nxh), -(mod(imax(k),ke)-nyh)
      end do
c
      stop
  992 format('No.=',i4,' k =',i4,1pe10.2,'  at (',i3,',',i3,')')
      end
c
      subroutine  esort ( emax, imax, n )
c
      dimension  emax(n), imax(n)
c
      do i = 1,n-1
        do j = i+1,n
          if ( emax(i) .lt. emax(j) ) then
            ee      = emax(i)
            emax(i) = emax(j)
            emax(j) = ee
            ii      = imax(i)
            imax(i) = imax(j)
            imax(j) = ii
          end if
        end do
      end do
c
      return
      end
