c **********************************************************************
c *   Decomposition of the TKE budget for POD analysis                 *
c *                                                                    *
c *   Results will be delivered to GMT command.                        *
c *                                                                    *
c *                                   Apr/2011  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "sub_eigen.f"
      include  "sub_KL_decomp.f"
      include  "sub_fourier.f"
      include  "../src/Parameter.h"
c
      include  "Paramodif.h"
c
      parameter ( mc=3, md=mc*(mc+1)/2, mp=mc+2, mpp=mp+1 )
      double precision  pr(mz,mz,md), pi(mz,mz,md)
      integer           ic(md)/ 1, 1, 1, 2, 2, 3/,
     :                  jc(md)/ 1, 2, 3, 2, 3, 3/
c
      double precision  bi(mmx,mmy,mz,mpp), bk(mmx,mmy,mz,mp)
      double precision  ave(mz,mc)
      double precision  csx(mmx), snx(mmx), csy(mmy), sny(mmy)
c
      double precision                     we2(mz*mc*mz*mc*4)
      double complex                       we1(mz*mc*mz*mc)
      integer                              iwe(mz*mc*5)
c
      character (len=4) :: f_name(mpp), p_name = 'pa11'
      character (len=5) :: r_num
      double precision  dat(mx,mz,my)
      data  f_name/ 'u___', 'v___', 'w___', 't___', 'pd__', 'fm__'/
c
      parameter ( mk=12 )
      integer           kx(mk,mk), ky(mk,mk), mode(mk,mk)
c
      double complex    tav(mz,mk), pav(mz,mk), aav(mk), aa, bb
      double precision  eval(mz*mc,mk),                  ar, br
      double complex    efun(mz*mc,mz*mc,mk)
c
      namelist  /les1/  nrun, nstep,  iout,  jout,  lout
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, phour, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
      namelist  /les3/  xbub,  ybub,  zbub,   xbr,   ybr,   zbr,  tbub,
     :                  reye
c
      namelist  /pod1/ r_num, irsta, irend, kmax
      namelist  /pod2/ irdecomp, kx, ky, mode
c
      irsta    = 1
      irend    = 999
      kmax     = 999
c
      do j = 1,mk
      do i = 1,mk
        kx(i,j)   = 9999
        ky(i,j)   = 9999
        mode(i,j) = 1
      end do
      end do
c
      read (5,nml=pod1)
      read (5,nml=pod2)
c
      open (10,file='para'//r_num,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop 'Para-file not found.'
c
      read (10,*) lx, lz, ly
c
      if ( lx .ne. mx .or. ly .ne. my .or. lz .ne. mz ) then
        write(6,*) 'mx, my, mz =', mx, my, mz
        write(6,*) 'lx, ly, lz =', lx, ly, lz
        stop 'Grid number is not consistent with Parameter.h!'
      end if
c
      read (10,nml=les1)
      read (10,nml=les2)
      read (10,nml=les3)
      close(10)
c
      nx2 = ( nx -2 )/mskip
      ny2 = ( ny -2 )/mskip
      nxh = ( nx2-1 )/2 +1
      nyh = ( ny2-1 )/2 +1
c
c   **  Note: Intel compiler option, -assume byterecl, is needed.  **
      lrec = 2*nz*nz * 8
c
      kmax = min( kmax, nz )
      nzc  = kmax*mc
c
      cel = 1.0/( 0.1*(dx*dy*dz)**(1.0/3.0) )
      gtr = 9.81/tref
      pkx = 6.283185/( dx*(nx-2) )
      pky = 6.283185/( dy*(ny-2) )
c
      call sub_kl_initial ( nx2, ny2, csx, snx, csy, sny )
c
      do j = 1,mk
        aav(j)   = ( 0.0d0, 0.0d0 )
      do k = 1,kmax
        tav(k,j) = ( 0.0d0, 0.0d0 )
        pav(k,j) = ( 0.0d0, 0.0d0 )
      end do
      end do
c
      open (41,file='paav'//r_num,form='unformatted',status='old')
c
      read (41) ( ( ave(k,m),k=1,nz ),m=1,mc )
c
      do id = 1,md
        write(p_name(3:4),'(2i1)') ic(id), jc(id)
c
        open (30+id,file=p_name//r_num,access='direct',recl=lrec,
     :              iostat=ios)
        if ( ios .ne. 0 ) stop 'pa??-file not found.'
      end do
c
      do m = 1,mpp
        open (10+m,file=f_name(m)//r_num,form='unformatted')
c
        do ir = 1,irsta-1
          read (10+m,end=100)
        end do
  100   continue
      end do
c
      do ir = irsta,irend
c
        do m = 1,mpp
          read (10+m,end=200) dat
c
          call coeff ( f_name(m) .eq. 'u___', ax1, bx1 )
          call coeff ( f_name(m) .eq. 'v___', ay1, by1 )
          call coeff ( f_name(m) .eq. 'w___', az1, bz1 )
c
          do k = 1,kmax
            do j = 1+mskip,ny-1,mskip
            do i = 1+mskip,nx-1,mskip
              im1 = (i-1)/mskip
              jm1 = (j-1)/mskip
c
              bi(im1,jm1,k,m) = ax1         * dat(i+1,k  ,j  )
     :                        +     ay1     * dat(i  ,k  ,j+1)
     :                        +         az1 * dat(i  ,k+1,j  )
     :                        + bx1*by1*bz1 * dat(i  ,k  ,j  )
            end do
            end do
          end do
        end do
c
          do k = 1,kmax
            do j = 1,mmy
            do i = 1,mmx
              bi(i,j,k,mp) = bi(i,j,k,mp )
     :            -2.0/3.0*( bi(i,j,k,mpp)*cel )**2
c
            do m = 1,mp
              bk(i,j,k,m)  = bi(i,j,k,m)
            end do
            end do
            end do
          end do
c
        icount = 0
c
c   **  Note: bud is printed out only for the first wavenumber.  **
        do ij = 1,mk
        do ik = 1,1
          kxm  = kx(ij,ik)
          kym  = ky(ij,ik)
          if ( abs(kxm) .ge. nxh .or. abs(kym) .ge. nyh ) cycle
c
c   **  Note: Fields for (kxm,kym) are the same as those for (-kxm,-kym).  **
          if ( kym .gt. 0 ) then
            kxm = -kxm
            kym = -kym
          end if
c
          idx  = min( max( nzc-mode(ij,ik)+1, 1 ), nzc )
c
          icount = icount +1
c   **
        if ( ir .eq. irsta ) then
          irec = kxm+nxh + nx2*( kym+nyh-1 )
c
          do id = 1,md
          read (30+id,rec=irec) ((pr(k,l,id),pi(k,l,id),k=1,nz),l=1,nz)
          end do
c
          call sub_eigen( 1, pr, pi, mz, kmax, dz, ic, jc, mc, md,
     :               eval(1,icount), efun(1,1,icount), we1, we2, iwe )
        end if
c   **
          do m = 1,mp
            call sub_fourier( bi(1,1,1,m), mmx, mmy, nx2, ny2, kmax,
     :                        kxm, kym, csx, snx, csy, sny )
          end do
c
          call sub_kl_decomp( 0, bi, mmx,mmy,mz, nx2,ny2,kmax, dz, mc,
     :               efun(1,idx,icount), kxm,kym, csx,snx,csy,sny, aa )
c
          i  = max( abs(kxm)*2, 1 )
          j  = max( abs(kym)*2, 1 )
                            sx = sign(1,kxm)
                            sy = sign(1,kym)
          if ( kxm .eq. 0 ) sx = 0.0
          if ( kym .eq. 0 ) sy = 0.0
c
            aav(icount)   = aav(icount)   +      conjg( aa )
c
          do k = 1,kmax
            bb = dcmplx(    bi(i  ,j,k,mp-1)-sx*sy*bi(i+1,j+1,k,mp-1),
     :                   sx*bi(i+1,j,k,mp-1)+   sy*bi(i  ,j+1,k,mp-1) )
            tav(k,icount) = tav(k,icount) + bb * conjg( aa )
c
            bb = dcmplx(    bi(i  ,j,k,mp  )-sx*sy*bi(i+1,j+1,k,mp  ),
     :                   sx*bi(i+1,j,k,mp  )+   sy*bi(i  ,j+1,k,mp  ) )
            pav(k,icount) = pav(k,icount) + bb * conjg( aa )
c
          do m = 1,mp
            bi(1  ,1  ,k,m) = bk(1  ,1  ,k,m)
            bi(i  ,j  ,k,m) = bk(i  ,j  ,k,m)
            bi(i  ,j+1,k,m) = bk(i  ,j+1,k,m)
            bi(i+1,j  ,k,m) = bk(i+1,j  ,k,m)
            bi(i+1,j+1,k,m) = bk(i+1,j+1,k,m)
          end do
          end do
        end do
        end do
c
        ntime = ir -irsta +1
      end do
c
  200 continue
c
      ih   = jmin +nint(nstot*dt)/60
      ih   = ih/60*100 +mod(ih,60)
c
      write(6,'(i5.4)') ih
      write(6,*) dz
      write(6,*) dz*kmax
      write(6,*) 'pod-budget'
c
      icount = 0
c
      do ij = 1,mk
      do ik = 1,1
        kxm  = kx(ij,ik)
        kym  = ky(ij,ik)
        if ( abs(kxm) .ge. nxh .or. abs(kym) .ge. nyh ) cycle
c
        if ( kym .gt. 0 ) then
          kxm = -kxm
          kym = -kym
        end if
c
        idx  = min( max( nzc-mode(ij,ik)+1, 1 ), nzc )
c
        icount = icount +1
c
        ang  = atan2( dble(kym), dble(kxm) )
        cs   = cos( ang )
        sn   = sin( ang )
c
        write(6,*) icount, 'k', kx(ij,ik), ky(ij,ik), nzc-idx+1
c
          aav(icount)   = aav(icount)   / dble(ntime)
        do k = 1,kmax
          tav(k,icount) = tav(k,icount) / dble(ntime)
          pav(k,icount) = pav(k,icount) / dble(ntime)
        end do
c
        do id = 1,md
          icp = kmax*( ic(id)-1 )
          jcp = kmax*( jc(id)-1 )
        do k  = 1,kmax
          pr(k,k,id) = eval(idx,icount)*efun(k+icp,idx,icount)
     :                          *conjg( efun(k+jcp,idx,icount) )
        end do
        end do
c
cx      elam = 1.0
        elam = eval(idx,icount)
c
c   **  To sum up fields at (kx,ky) and (-kx,-ky), multiplied by 2.  **
        do k = 2,kmax
          du  = ( ave(k,1) -ave(k-1,1) ) / dz
          dv  = ( ave(k,2) -ave(k-1,2) ) / dz
          fu  = -pr(k,k,3) -pr(k-1,k-1,3)
          fv  = -pr(k,k,5) -pr(k-1,k-1,5)
c
          bud = ( du*cs+dv*sn )*( fu*cs+fv*sn )
          write(6,*) icount, 'Sc', bud/elam, dz*(k-1)
          bud = (-du*sn+dv*cs )*(-fu*sn+fv*cs )
          write(6,*) icount, 'Sa', bud/elam, dz*(k-1)
        end do
c
        do k = 1,kmax
          bud = 2.0*gtr
     :         *real( tav(k,icount)*conjg(efun(k+kmax*2,idx,icount)) )
          write(6,*) icount, 'B', bud/elam, dz*(k-0.5)
        end do
c
        do k = 1,kmax
          pu = 2.0*kxm*pkx
          ru = imag( pav(k,icount)*conjg(efun(k     ,idx,icount)) )
          pv = 2.0*kym*pky
          rv = imag( pav(k,icount)*conjg(efun(k+kmax,idx,icount)) )
c
          bud = ( pu*cs+pv*sn )*( ru*cs+rv*sn )
          write(6,*) icount, 'Rc', bud/elam, dz*(k-0.5)
          bud = (-pu*sn+pv*cs )*(-ru*sn+rv*cs )
          write(6,*) icount, 'Ra', bud/elam, dz*(k-0.5)
          bud =  -pu*ru-pv*rv
          write(6,*) icount, 'Rw', bud/elam, dz*(k-0.5)
        end do
c
        do k = 1,kmax
          uu  = ave(k,1) / reye
          vv  = ave(k,2) / reye
          fu  = pr(k,k,4) -pr(k,k,1)
          fv  = pr(k,k,2)
c
          bud = (-uu*sn+vv*cs )*( fu*cs*sn+fv*(cs*cs-sn*sn) )
          write(6,*) icount, 'Cc', bud/elam, dz*(k-0.5)
          write(6,*) icount, 'Ca',-bud/elam, dz*(k-0.5)
        end do
c
        do k = 2,kmax
          ar  = 2.0*pr(k  ,k  ,2)*cs*sn
          br  = 2.0*pr(k-1,k-1,2)*cs*sn
c
          bud =-( pr(k  ,k  ,1)*cs*cs+pr(k  ,k  ,4)*sn*sn+ar )
     :           *aav(icount)*conjg(efun(k  +kmax*2,idx,icount))
     :         +( pr(k-1,k-1,1)*cs*cs+pr(k-1,k-1,4)*sn*sn+br )
     :           *aav(icount)*conjg(efun(k-1+kmax*2,idx,icount))
          all = bud
          write(6,*) icount, 'Tc', bud/elam/dz, dz*(k-1)
c
          bud =-( pr(k  ,k  ,1)*sn*sn+pr(k  ,k  ,4)*cs*cs-ar )
     :           *aav(icount)*conjg(efun(k  +kmax*2,idx,icount))
     :         +( pr(k-1,k-1,1)*sn*sn+pr(k-1,k-1,4)*cs*cs-br )
     :           *aav(icount)*conjg(efun(k-1+kmax*2,idx,icount))
          all = all +bud
          write(6,*) icount, 'Ta', bud/elam/dz, dz*(k-1)
c
          bud =-( pr(k  ,k  ,6)*aav(icount)+2.0*pav(k  ,icount) )
     :                       *conjg(efun(k  +kmax*2,idx,icount))
     :         +( pr(k-1,k-1,6)*aav(icount)+2.0*pav(k-1,icount) )
     :                       *conjg(efun(k-1+kmax*2,idx,icount))
          all = all +bud
          write(6,*) icount, 'Tw+P', bud/elam/dz, dz*(k-1)
c
          write(6,*) icount, 'T+P',  all/elam/dz, dz*(k-1)
        end do
      end do
      end do
c
      stop
      end
c
      subroutine  coeff ( agree, aa, bb )
c
      logical  agree
c
                   aa = 0.0
      if ( agree ) aa = 0.5
                   bb = 1.0 -aa
c
      return
      end
