c **********************************************************************
c *   Eigenfunctions for POD analysis                                  *
c *                                                                    *
c *   Results will be delivered to GMT command.                        *
c *                                                                    *
c *                                   May/2010  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "sub_eigen.f"
      include  "../src/Parameter.h"
c
      include  "Paramodif.h"
c
      parameter ( mc=3, md=mc*(mc+1)/2 )
      double precision  pr(mz,mz,md), pi(mz,mz,md)
      integer           ic(md)/ 1, 1, 1, 2, 2, 3/,
     :                  jc(md)/ 1, 2, 3, 2, 3, 3/
c
      character (len=1) :: qnt(mc) = (/'u', 'v', 'w'/)
c
      double precision  eval(mz*mc),       we2(mz*mc*mz*mc*4)
      double complex    efun(mz*mc,mz*mc), we1(mz*mc*mz*mc)
      integer                              iwe(mz*mc*5)
c
      character (len=4) :: p_name = 'pa11'
      character (len=5) :: r_num
c
      parameter ( mk=12 )
      integer           kx(mk,mk), ky(mk,mk), mode(mk,mk)
c
      namelist  /les1/  nrun, nstep,  iout,  jout,  lout
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, phour, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
c
      namelist  /pod1/ r_num, irsta, irend, kmax
      namelist  /pod2/ irdecomp, kx, ky, mode
c
      kmax     = 999
c
      do j = 1,mk
      do i = 1,mk
        kx(i,j)   = 9999
        ky(i,j)   = 9999
        mode(i,j) = 1
      end do
      end do
c
      read (5,nml=pod1)
      read (5,nml=pod2)
c
      open (10,file='para'//r_num,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop 'Para-file not found.'
c
      read (10,*) lx, lz, ly
c
      if ( lx .ne. mx .or. ly .ne. my .or. lz .ne. mz ) then
        write(6,*) 'mx, my, mz =', mx, my, mz
        write(6,*) 'lx, ly, lz =', lx, ly, lz
        stop 'Grid number is not consistent with Parameter.h!'
      end if
c
      read (10,nml=les1)
      read (10,nml=les2)
      close(10)
c
      nx2 = ( nx -2 )/mskip
      ny2 = ( ny -2 )/mskip
      nxh = ( nx2-1 )/2 +1
      nyh = ( ny2-1 )/2 +1
c
c   **  Note: Intel compiler option, -assume byterecl, is needed.  **
      lrec = 2*nz*nz * 8
c
      kmax = min( kmax, nz )
      nzc  = kmax*mc
c
      do id = 1,md
        write(p_name(3:4),'(2i1)') ic(id), jc(id)
c
        open (30+id,file=p_name//r_num,access='direct',recl=lrec,
     :              iostat=ios)
        if ( ios .ne. 0 ) stop 'pa??-file not found.'
      end do
c
      ih   = jmin +nint(nstot*dt)/60
      ih   = ih/60*100 +mod(ih,60)
c
      write(6,'(i5.4)') ih
      write(6,*) dz
      write(6,*) dz*kmax
      write(6,*) 'pod-eigenfunction'
c
      icount = 0
c
c   **  Note: eigenfunc is printed out only for the first wavenumber.  **
      do ij = 1,mk
      do ik = 1,1
        kxm  = kx(ij,ik)
        kym  = ky(ij,ik)
        if ( abs(kxm) .ge. nxh .or. abs(kym) .ge. nyh ) cycle
c
c   **  Note: Fields for (kxm,kym) are the same as those for (-kxm,-kym).  **
        if ( kym .gt. 0 ) then
          kxm = -kxm
          kym = -kym
        end if
c
        idx  = min( max( nzc-mode(ij,ik)+1, 1 ), nzc )
c
        irec = kxm+nxh + nx2*( kym+nyh-1 )
c
        do id = 1,md
          read (30+id,rec=irec) ((pr(k,l,id),pi(k,l,id),k=1,nz),l=1,nz)
        end do
c
        call sub_eigen( 1, pr, pi, mz, kmax, dz, ic, jc, mc, md,
     :                  eval, efun, we1, we2, iwe )
c
        icount = icount +1
c
        write(6,*) icount, 'k', kx(ij,ik), ky(ij,ik), nzc-idx+1
c
        do id = 1,mc
          ki = kmax*( id-1 )
c
          do k = 1,kmax
            eif = abs( efun(k+ki,idx) )
c
            write(6,*) icount, qnt(id), eif, dz*(k-0.5)
          end do
        end do
      end do
      end do
c
      stop
      end
