c
      subroutine  sub_fourier (
     m                    bi,
     i                    mx, my, nx, ny, nz,
     i                    kxm, kym,
     i                    csx, snx, csy, sny )
c
c     Input variables:
c       bi              : Physical quantity
c       kxm, kym        : Wavenumber
c                         -nxh < kxm < nxh, -nyh < kym < nyh
c       csx, ..., sny   : Table of the trigonometric functions,
c                         obtained from sub_kl_initial
c
c     Output variables:
c       bi              : Fourier coefficients for (kxm,kym)
c
      double precision  bi(mx,my,nz)
      double precision  csx(mx), snx(mx), csy(my), sny(my)
      double precision  ave, ana, anb, bna, bnb, ani, bni
c
      kx   = abs(kxm)
      ky   = abs(kym)
      rsum = 1.0/dble(nx*ny)
c
      do k = 1,nz
        ave = 0.0
        ana = 0.0
        anb = 0.0
        bna = 0.0
        bnb = 0.0
c
        do j = 1,ny
          ani = 0.0
          bni = 0.0
        do i = 1,nx
          ii  = mod( kx*(i-1), nx ) +1
          ani = ani +bi(i,j,k)*csx(ii)
          bni = bni -bi(i,j,k)*snx(ii)
          ave = ave +bi(i,j,k)
        end do
          jj  = mod( ky*(j-1), ny ) +1
          ana = ana +ani    *csy(jj)
          anb = anb -ani    *sny(jj)
          bna = bna +bni    *csy(jj)
          bnb = bnb -bni    *sny(jj)
        end do
c
        i  = max( kx*2, 1 )
        j  = max( ky*2, 1 )
        bi(1  ,1  ,k) = ave * rsum
        bi(i  ,j  ,k) = ana * rsum
        bi(i  ,j+1,k) = anb * rsum
        bi(i+1,j  ,k) = bna * rsum
        bi(i+1,j+1,k) = bnb * rsum
      end do
c
      return
      end
