c **********************************************************************
c *   Calculates second moments                                        *
c *                                                                    *
c *   Input parameters:                                                *
c *     r_num         : Run number                      (Run.Restart)  *
c *                   : For example, 01.01                             *
c *                                                                    *
c *                                   Jan/2010  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "sub_bc.f"
      include  "sub_flux_m.f"
      include  "sub_flux_s.f"
      include  "sub_flux_v.f"
      include  "sub_eps.f"
c
      include  "../src/Implicit.h"
c
      parameter ( mx=502, my=502, mz=201 )
      parameter ( mip=17, mop=7, one=1.0 )
c
      character (len=5) :: r_num
      character (len=4) :: f_name(mip) =
     3                 (/'u___', 'v___', 'w___', 't___', 'q___',
     3                   'fm__', 'fh__', 'pd__',
     3                   'ql__', 'vt__', 'vq__',
     2                   'flm_', 'flt_', 'flq_',
     1                   'gam_', 'fwu_', 'fvw_'                /)
      character (len=4) :: o_name(mop) =
     :                 (/'ztke', 'zwu_', 'zwv_', 'zeps',
     :                   'zwtv', 'zwt_', 'zwq_'                /)
c
      dimension  u (mx,mz,my), v (mx,mz,my), w (mx,mz,my)
      dimension  t (mx,mz,my), q (mx,mz,my)
      dimension  fm(mx,mz,my), fh(mx,mz,my), pd(mx,mz,my)
      dimension  ql(mx,mz,my), vt(mx,mz,my), vq(mx,mz,my)
      dimension  flm(mx,my), flt(mx,my), flq(mx,my)
      dimension  gam(mz), fwu(mz), fvw(mz)
c
      dimension  uav(mz), vav(mz), tav(mz)
      dimension  uu(mx,mz,my), vv(mx,mz,my), ww(mx,mz,my)
      dimension  uv(mx,mz,my), vw(mx,mz,my), wu(mx,mz,my)
      dimension  eps(mx,mz,my)
c
      namelist  /les1/  nrun, nstep,  iout,  jout,  lout
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, phour, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
c
      namelist  /post/ r_num
c
      r_num    = ''
c
      read (5,nml=post)
c
      open (10,file='para'//r_num,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop 'para-file not found.'
c
      read (10,*) lx, lz, ly
      read (10,*) nx, nz, ny
c
      if ( lx .gt. mx .or. ly .gt. my .or. lz .gt. mz ) then
                        write(6,*) 'nx, ny, nz =', nx, ny, nz
                        stop 'Grid number is large!'
      end if
c
      read (10,nml=les1)
      read (10,nml=les2)
c
      close(10)
c
      do k = 1,lz
        gam(k) = 1.0
        fwu(k) = 0.0
        fvw(k) = 0.0
      end do
c
      do m = 1,mip
        open (m+20,file=f_name(m)//r_num,form='unformatted',
     :              status='old',iostat=ios)
        if ( ios .ne. 0 ) f_name(m) = 'xxxx'
      end do
      do m = 1,mop
        if ( icon .lt. 0 .and. o_name(m) .eq. 'zwq_' ) cycle
        open (m+60,file=o_name(m)//r_num,form='unformatted')
      end do
c
      do krec = 1,99
        do m = 1,mip
          mt = m +20
c
          select case ( f_name(m) )
            case ( 'u___' )
              read (mt,end=999) (((u  (i,k,j),i=1,lx),k=1,lz),j=1,ly)
            case ( 'v___' )
              read (mt,end=999) (((v  (i,k,j),i=1,lx),k=1,lz),j=1,ly)
            case ( 'w___' )
              read (mt,end=999) (((w  (i,k,j),i=1,lx),k=1,lz),j=1,ly)
            case ( 't___' )
              read (mt,end=999) (((t  (i,k,j),i=1,lx),k=1,lz),j=1,ly)
            case ( 'q___' )
              read (mt,end=999) (((q  (i,k,j),i=1,lx),k=1,lz),j=1,ly)
            case ( 'fm__' )
              read (mt,end=999) (((fm (i,k,j),i=1,lx),k=1,lz),j=1,ly)
            case ( 'fh__' )
              read (mt,end=999) (((fh (i,k,j),i=1,lx),k=1,lz),j=1,ly)
            case ( 'pd__' )
              read (mt,end=999) (((pd (i,k,j),i=1,lx),k=1,lz),j=1,ly)
            case ( 'ql__' )
              read (mt,end=999) (((ql (i,k,j),i=1,lx),k=1,lz),j=1,ly)
            case ( 'vt__' )
              read (mt,end=999) (((vt (i,k,j),i=1,lx),k=1,lz),j=1,ly)
            case ( 'vq__' )
              read (mt,end=999) (((vq (i,k,j),i=1,lx),k=1,lz),j=1,ly)
            case ( 'flm_' )
              read (mt,end=999) ( (flm(i,  j),i=1,lx),        j=1,ly)
            case ( 'flt_' )
              read (mt,end=999) ( (flt(i,  j),i=1,lx),        j=1,ly)
            case ( 'flq_' )
              read (mt,end=999) ( (flq(i,  j),i=1,lx),        j=1,ly)
            case ( 'gam_' )
              read (mt,end=999)   (gam(  k  ),        k=1,lz)
            case ( 'fwu_' )
              read (mt,end=999)   (fwu(  k  ),        k=1,lz)
            case ( 'fvw_' )
              read (mt,end=999)   (fvw(  k  ),        k=1,lz)
          end select
        end do
c
        call sub_flux_m ( one,
     i                  mx, mz, nx, nz, ny, dx, dz, dy,
     i                  u, v, w, fm, gam, fwu, fvw, flm,
     w                  uav, vav,
     o                  uu, vv, ww, uv, vw, wu )
c
        do j = 1,ly
        do k = 1,lz
        do i = 1,lx
          uu(i,k,j) = 0.5*( uu(i,k,j)+vv(i,k,j)+ww(i,k,j) )
        end do
        end do
        end do
c
        do m = 1,mop
          mt = m +60
          select case ( o_name(m) )
            case ( 'ztke' )
              write(mt) ( ( ( uu(i,k,j),i=1,lx ),k=1,lz ),j=1,ly )
            case ( 'zwu_' )
              write(mt) ( ( ( wu(i,k,j),i=1,lx ),k=1,lz ),j=1,ly )
            case ( 'zwv_' )
              write(mt) ( ( ( vw(i,k,j),i=1,lx ),k=1,lz ),j=1,ly )
          end select
        end do
c
        call sub_eps (
     i                  mx, mz, nx, nz, ny, dx, dz, dy,
     i                  u, v, w, fm, gam, fwu, fvw, flm,
     w                  uav, vav,
     w                  uu, vv, ww, uv, vw, wu,
     o                  eps )
c
        do m = 1,mop
          mt = m +60
          select case ( o_name(m) )
            case ( 'zeps' )
              write(mt) ( ( ( eps(i,k,j),i=1,lx ),k=1,lz ),j=1,ly )
          end select
        end do
c
        call sub_flux_v ( one,
     i                  mx, mz, nx, nz, ny, dx, dz, dy, tref, psf,
     i                  u, v, w, t, q, ql, fh, vt, vq, flt, flq,
     w                  uav, vav, tav,
     o                  uu, vv, ww, uv )
c
        do m = 1,mop
          mt = m +60
          select case ( o_name(m) )
            case ( 'zwtv' )
              write(mt) ( ( ( ww(i,k,j),i=1,lx ),k=1,lz ),j=1,ly )
          end select
        end do
c
        call sub_flux_s (
     i                  mx, mz, nx, nz, ny, dx, dz, dy,
     i                  u, v, w, t, fh, flt,
     w                  uav, vav, tav,
     o                  uu, vv, ww )
c
        do m = 1,mop
          mt = m +60
          select case ( o_name(m) )
            case ( 'zwt_' )
              write(mt) ( ( ( ww(i,k,j),i=1,lx ),k=1,lz ),j=1,ly )
          end select
        end do
c
        if ( icon .lt. 0 ) cycle
c
        call sub_flux_s (
     i                  mx, mz, nx, nz, ny, dx, dz, dy,
     i                  u, v, w, q, fh, flq,
     w                  uav, vav, tav,
     o                  uu, vv, ww )
c
        do m = 1,mop
          mt = m +60
          select case ( o_name(m) )
            case ( 'zwq_' )
              write(mt) ( ( ( ww(i,k,j),i=1,lx ),k=1,lz ),j=1,ly )
          end select
        end do
      end do
c
  999 stop
      end
