c **********************************************************************
c *   Calculates vorticities                                           *
c *                                                                    *
c *   Input parameters:                                                *
c *     r_num         : Run number                      (Run.Restart)  *
c *                   : For example, 01.01                             *
c *                                                                    *
c *                                   Jan/2010  M. Nakanishi (N.D.A)   *
c **********************************************************************
c
      include  "sub_bc.f"
      include  "sub_vor.f"
c
      include  "../src/Implicit.h"
c
      parameter ( mx=502, my=502, mz=201 )
      parameter ( mip=3, mop=4, one=1.0 )
c
      character (len=5) :: r_num
      character (len=4) :: f_name(mip) =
     3                 (/'u___', 'v___', 'w___'/)
      character (len=4) :: o_name(mop) =
     :                 (/'zx__', 'zy__', 'zz__', 'ze__'/)
c
      dimension  u (mx,mz,my), v (mx,mz,my), w (mx,mz,my)
c
      dimension  zx(mx,mz,my), zy(mx,mz,my), zz(mx,mz,my)
      dimension  ze(mx,mz,my)
c
      namelist  /les1/  nrun, nstep,  iout,  jout,  lout
      namelist  /les2/  isgs,  isfc,  irad,  icon,  isca,
     :                  jmin,  rlat,    dt,    dx,    dy,    dz,
     :                         ugsf,  vgsf,         aglw,  agmd,
     :                  gulw,  gvlw,  gumd,  gvmd,
     :                  tref,   tsf,   qsf,   psf,  hglw,  hgmd,
     :                  gtlw,  gqlw,  gtmd,  gqmd,  gamt,  gamq,
     :                   z0m,   z0h,  tfmx,  qfmx, phour, dhour,
     :                 tdeep,  swet,  crso,  fkso,
     :                  elat,  albd,  clov,  ulov,
     :                 nflay, frate,
     :                  nspl,  nspu,   csp, nstot
c
      namelist  /post/ r_num
c
      r_num    = ''
c
      read (5,nml=post)
c
      open (10,file='para'//r_num,status='old',iostat=ios)
      if ( ios .ne. 0 ) stop 'para-file not found.'
c
      read (10,*) lx, lz, ly
      read (10,*) nx, nz, ny
c
      if ( lx .gt. mx .or. ly .gt. my .or. lz .gt. mz ) then
                        write(6,*) 'nx, ny, nz =', nx, ny, nz
                        stop 'Grid number is large!'
      end if
c
      read (10,nml=les1)
      read (10,nml=les2)
c
      close(10)
c
      do m = 1,mip
        open (m+20,file=f_name(m)//r_num,form='unformatted',
     :              status='old',iostat=ios)
        if ( ios .ne. 0 ) f_name(m) = 'xxxx'
      end do
      do m = 1,mop
        open (m+60,file=o_name(m)//r_num,form='unformatted')
      end do
c
      do krec = 1,99
        do m = 1,mip
          mt = m +20
c
          select case ( f_name(m) )
            case ( 'u___' )
              read (mt,end=999) (((u  (i,k,j),i=1,lx),k=1,lz),j=1,ly)
            case ( 'v___' )
              read (mt,end=999) (((v  (i,k,j),i=1,lx),k=1,lz),j=1,ly)
            case ( 'w___' )
              read (mt,end=999) (((w  (i,k,j),i=1,lx),k=1,lz),j=1,ly)
          end select
        end do
c
        call sub_vor (
     i                  mx, mz, nx, nz, ny, dx, dz, dy,
     i                  u, v, w,
     o                  zx, zy, zz )
c
        do j = 2,ny-1
        do k = 2,nz
        do i = 2,nx-1
          ze(i,k,j) = 0.03125*( ( zx( i ,k+1,j+1)+zx( i , k ,j+1)
     :                           +zx( i ,k+1, j )+zx( i , k , j ) )**2
     :                         +( zy(i+1,k+1, j )+zy(i+1, k , j )
     :                           +zy( i ,k+1, j )+zy( i , k , j ) )**2
     :                         +( zz(i+1, k ,j+1)+zz(i+1, k , j )
     :                           +zz( i , k ,j+1)+zz( i , k , j ) )**2 )
        end do
        end do
        end do
c
        call sub_bc ( mx, mz, nx, nz, ny, ze )
c
        do m = 1,mop
          mt = m +60
          select case ( o_name(m) )
            case ( 'zx__' )
              write(mt) ( ( ( zx(i,k,j),i=1,lx ),k=1,lz ),j=1,ly )
            case ( 'zy__' )
              write(mt) ( ( ( zy(i,k,j),i=1,lx ),k=1,lz ),j=1,ly )
            case ( 'zz__' )
              write(mt) ( ( ( zz(i,k,j),i=1,lx ),k=1,lz ),j=1,ly )
            case ( 'ze__' )
              write(mt) ( ( ( ze(i,k,j),i=1,lx ),k=1,lz ),j=1,ly )
          end select
        end do
      end do
c
  999 stop
      end
