c **********************************************************************
c *   Scalar covariances                                               *
c *                                                                    *
c *   # fm is used for calculating subgrid-scale TKE.                  *
c **********************************************************************
c
      subroutine  sub_cov_s (
     i                  mx, mz, nx, nz, ny, dx, dz, dy,
     i                  t, q, fh, fm,
     w                  tav, qav,
     w                  uu, vv, ww,
     o                  var )
c
      include  "../src/Implicit.h"
c
      dimension  t (mx,mz,ny), q (mx,mz,ny), fh(mx,mz,ny), fm(mx,mz,ny)
      dimension  tav(mz), qav(mz)
      dimension  uu(mx,mz,ny), vv(mx,mz,ny), ww(mx,mz,ny)
      dimension  var(mx,mz,ny)
c
      rsum = 1.0/dble((nx-2)*(ny-2))
      anu  = 1.5e-5
      qnu  = 2.1e-5
      ctl  = 2.0*(dx*dy*dz)**(2.0/3.0) * 0.1/2.1
c
      do k = 1,nz+1
        tav(k) = 0.0
        qav(k) = 0.0
        do j = 2,ny-1
        do i = 2,nx-1
          tav(k) = tav(k) +t (i,k,j)
          qav(k) = qav(k) +q (i,k,j)
        end do
        end do
        tav(k) = tav(k) * rsum
        qav(k) = qav(k) * rsum
      end do
c
      do j = 1,ny
      do k = 1,nz+1
      do i = 1,nx
        var(i,k,j) = ctl*( fh(i,k,j)+qnu )/( fm(i,k,j)+anu )
      end do
      end do
      end do
c
      do j = 2,ny
      do k = 1,nz
      do i = 2,nx
        f1 = 0.5*( var(i,k,j)+var(i-1, k , j ) )
        f2 = 0.5*( var(i,k,j)+var( i , k ,j-1) )
c
        uu(i,k,j) = f1 * ( t (i,k,j)-t (i-1, k , j ) ) / dx
     :                 * ( q (i,k,j)-q (i-1, k , j ) ) / dx
        vv(i,k,j) = f2 * ( t (i,k,j)-t ( i , k ,j-1) ) / dy
     :                 * ( q (i,k,j)-q ( i , k ,j-1) ) / dy
      end do
      end do
      end do
c
      do j = 2,ny-1
      do k = 2,nz+1
      do i = 1,mx
        f1 = 0.5*( var(i,k,j)+var( i ,k-1, j ) )
c
        ww(i,k,j) = f1 * ( t (i,k,j)-t ( i ,k-1, j ) ) / dz
     :                 * ( q (i,k,j)-q ( i ,k-1, j ) ) / dz
      end do
      end do
      end do
c
c  ***  Lower boundary condition  ***
      do j = 2,ny-1
      do i = 2,nx-1
        ww(i,1,j) =  0.0
      end do
      end do
c
      do j = 2,ny-1
      do k = 1,nz
      do i = 2,nx-1
        var(i,k,j) =     ( t ( i , k , j )-tav(k)    )
     :                  *( q ( i , k , j )-qav(k)    )
     :              +0.5*( uu(i+1, k , j )+uu(i,k,j)
     :                    +vv( i , k ,j+1)+vv(i,k,j)
     :                    +ww( i ,k+1, j )+ww(i,k,j) )
      end do
      end do
      end do
c
      call sub_bc ( mx, mz, nx, nz, ny, var )
c
      return
      end
