c **********************************************************************
c *   Input of the simulation data                                     *
c *                                                                    *
c *   # Sequential-access files are opened as direct-access files:     *
c *   # The record length (recl) is increased by 8 (=4*2).             *
c **********************************************************************
c
      subroutine  sub_data_open (
     i                  r_num, f_name, mt,
     i                  lx, lz, ly )
c
      include  "../src/Implicit.h"
c
      character (len=5) :: r_num
      character (len=4) :: f_name
c
      select case ( f_name )
c  2D data
        case ( 'flm_', 'flt_', 'flq_', 'ts__' )
          lrec = lx   *ly * sizeof(a) + 8
c
c  1D data
        case ( 'gam_', 'fwu_', 'fvw_' )
          lrec =    lz    * sizeof(a) + 8
c
c  3D data
        case default
          lrec = lx*lz*ly * sizeof(a) + 8
      end select
c
      open (mt,file=f_name//r_num,access='direct',recl=lrec,
     :         status='old',iostat=ios)
c
      if ( ios .ne. 0 ) f_name = 'xxxx'
c
      return
      end
c
      subroutine  sub_data_input (
     i                  mt, irec,
     i                  mx, mz, my, lx, lz, ly,
     o                  dat )
c
c     Note:
c       2D data, dat(mx,mz) : my = ly = 1
c       1D data, dat(mx)    : mz = lz = 1 and my = ly = 1
c
      include  "../src/Implicit.h"
c
      dimension  dat(mx,mz,my)
c
      jrec = max( irec, 1 )
c
      read (mt,rec=jrec,iostat=ios)
     :     idummy, ( ( ( dat(i,k,j),i=1,lx ),k=1,lz ),j=1,ly )
c
      if ( ios .ne. 0 ) irec = 999
c
      return
      end
