c **********************************************************************
c *   Turbulent fluxes of scalar quantities                            *
c *                                                                    *
c *   # This is adapted from src/flux_s.f.                             *
c **********************************************************************
c
      subroutine  sub_flux_s (
     i                  mx, mz, nx, nz, ny, dx, dz, dy,
     i                  u, v, w, tq, fq, sflx,
     w                  uav, vav, tav,
     o                  uu, vv, ww )
c
      include  "../src/Implicit.h"
c
      dimension  u (mx,mz,ny), v (mx,mz,ny), w (mx,mz,ny)
      dimension  tq(mx,mz,ny), fq(mx,mz,ny)
      dimension  sflx(mx,ny)
      dimension  uav(mz), vav(mz), tav(mz)
      dimension  uu(mx,mz,ny), vv(mx,mz,ny), ww(mx,mz,ny)
c
      rsum = 1.0/dble((nx-2)*(ny-2))
      qnu  = 2.1e-5
c
      do k = 1,nz+1
        uav(k) = 0.0
        vav(k) = 0.0
        tav(k) = 0.0
        do j = 2,ny-1
        do i = 2,nx-1
          uav(k) = uav(k) +u (i,k,j)
          vav(k) = vav(k) +v (i,k,j)
          tav(k) = tav(k) +tq(i,k,j)
        end do
        end do
        uav(k) = uav(k) * rsum
        vav(k) = vav(k) * rsum
        tav(k) = tav(k) * rsum
      end do
c
      do j = 2,ny
      do k = 1,nz
      do i = 2,nx
        f1 = 0.5*( fq(i,k,j)+fq(i-1, k , j ) ) +qnu
        f2 = 0.5*( fq(i,k,j)+fq( i , k ,j-1) ) +qnu
c
        uu(i,k,j) =  0.5*( tq(i,k,j)+tq(i-1, k , j )-2.0*tav(k) )
     :                  *( u (i,k,j)                -    uav(k) )
     :              -f1 *( tq(i,k,j)-tq(i-1, k , j ) ) / dx
        vv(i,k,j) =  0.5*( tq(i,k,j)+tq( i , k ,j-1)-2.0*tav(k) )
     :                  *( v (i,k,j)                -    vav(k) )
     :              -f2 *( tq(i,k,j)-tq( i , k ,j-1) ) / dy
      end do
      end do
      end do
c
      do j = 2,ny-1
      do k = 2,nz+1
      do i = 1,mx
        f1 = 0.5*( fq(i,k,j)+fq( i ,k-1, j ) ) +qnu
c
        ww(i,k,j) =  0.5*( tq(i,k,j)+tq( i ,k-1, j )-tav(k)-tav(k-1) )
     :                  *  w (i,k,j)
     :              -f1 *( tq(i,k,j)-tq( i ,k-1, j ) ) / dz
      end do
      end do
      end do
c
c  ***  Lower boundary condition  ***
      do j = 2,ny-1
      do i = 2,nx-1
        ww(i,1,j) =  sflx(i,j)
      end do
      end do
c
      call sub_bc ( mx, mz, nx, nz, ny, uu )
      call sub_bc ( mx, mz, nx, nz, ny, vv )
      call sub_bc ( mx, mz, nx, nz, ny, ww )
c
      return
      end
