c **********************************************************************
c *   Vertical fluxes of TKE and pressure                              *
c *                                                                    *
c *   # Vertical resolved-scale fluxes only                            *
c **********************************************************************
c
      subroutine  sub_flux_tp3 (
     i                  mx, mz, nx, nz, ny, dx, dz, dy,
     i                  u, v, w, fm, pd,
     w                  uav, vav,
     o                  uu, vv, ww, uv )
c
      include  "../src/Implicit.h"
c
      dimension  u (mx,mz,ny), v (mx,mz,ny), w (mx,mz,ny), fm(mx,mz,ny)
      dimension  pd(mx,mz,ny)
      dimension  uav(mz), vav(mz)
      dimension  uu(mx,mz,ny), vv(mx,mz,ny), ww(mx,mz,ny)
      dimension  uv(mx,mz,ny)
c
      rsum = 1.0/dble((nx-2)*(ny-2))
      cel  = 1.0/( 0.1*(dx*dy*dz)**(1.0/3.0) )
c
      do k = 1,nz+1
        uav(k) = 0.0
        vav(k) = 0.0
        do j = 2,ny-1
        do i = 2,nx-1
          uav(k) = uav(k) +u (i,k,j)
          vav(k) = vav(k) +v (i,k,j)
        end do
        end do
        uav(k) = uav(k) * rsum
        vav(k) = vav(k) * rsum
      end do
c
      do j = 2,ny-1
      do k = 1,nz
      do i = 2,nx-1
        uu(i,k,j) = 0.125*  ( u (i+1, k , j )+u (i,k,j)-2.0*uav(k) )**2
        vv(i,k,j) = 0.125*  ( v ( i , k ,j+1)+v (i,k,j)-2.0*vav(k) )**2
        ww(i,k,j) = 0.125*  ( w ( i ,k+1, j )+w (i,k,j) )**2
     :             +          pd( i , k , j )
     :             -2.0/3.0*( fm( i , k , j )*cel )**2
      end do
      end do
      end do
c
      do j = 2,ny-1
      do k = nz+1,2,-1
      do i = 2,nx-1
        uu(i,k,j) = 0.5*( uu(i,k,j)+uu( i ,k-1, j ) ) * w (i,k,j)
        vv(i,k,j) = 0.5*( vv(i,k,j)+vv( i ,k-1, j ) ) * w (i,k,j)
        ww(i,k,j) = 0.5*( ww(i,k,j)+ww( i ,k-1, j ) ) * w (i,k,j)
      end do
      end do
      end do
c
c  ***  Boundary condition  ***
      do j = 1,ny
      do i = 1,nx
        uu(i,   1,j) = 0.0
        vv(i,   1,j) = 0.0
        ww(i,   1,j) = 0.0
      end do
      end do
c
      call sub_bc ( mx, mz, nx, nz, ny, uu )
      call sub_bc ( mx, mz, nx, nz, ny, vv )
      call sub_bc ( mx, mz, nx, nz, ny, ww )
c
      return
      end
