c **********************************************************************
c *   Redistribution terms for <uv>, <uw>, and <vw>                    *
c **********************************************************************
c
      subroutine  sub_redistribution4non (
     i                  mx, mz, nx, nz, ny, dx, dz, dy,
     i                  u, v, w, fm, pd,
     w                  pav,
     o                  uv, wu, vw, uu )
c
      include  "../src/Implicit.h"
c
      dimension  u (mx,mz,ny), v (mx,mz,ny), w (mx,mz,ny), fm(mx,mz,ny)
      dimension  pd(mx,mz,ny)
      dimension  pav(mz)
      dimension  uv(mx,mz,ny), wu(mx,mz,ny), vw(mx,mz,ny)
      dimension  uu(mx,mz,ny)
c
      rsum = 1.0/dble((nx-2)*(ny-2))
      cel  = 1.0/( 0.1*(dx*dy*dz)**(1.0/3.0) )
c
      do k = 1,nz+1
        pav(k) = 0.0
        do j = 2,ny-1
        do i = 2,nx-1
          pav(k) = pav(k) +pd(i,k,j)-2.0/3.0*(fm(i,k,j)*cel)**2
        end do
        end do
        pav(k) = pav(k) * rsum
      end do
c
      do j = 1,ny-1
      do k = 1,nz
      do i = 1,nx-1
        uu(i,k,j) = pd(i,k,j)-2.0/3.0*(fm(i,k,j)*cel)**2 -pav(k)
      end do
      end do
      end do
c
      do j = 2,ny-1
      do k = 1,nz
        m    = k +1
      do i = 2,nx-1
        uv(i,k,j) = 0.25*( uu( i , k , j )+uu(i-1, k , j )
     :                    +uu( i , k ,j-1)+uu(i-1, k ,j-1) )
     :                *( ( u ( i , k , j )-u ( i , k ,j-1) ) / dy
     :                  +( v ( i , k , j )-v (i-1, k , j ) ) / dx )
        wu(i,m,j) = 0.25*( uu( i , m , j )+uu(i-1, m , j )
     :                    +uu( i ,m-1, j )+uu(i-1,m-1, j ) )
     :                *( ( u ( i , m , j )-u ( i ,m-1, j ) ) / dz
     :                  +( w ( i , m , j )-w (i-1, m , j ) ) / dx )
        vw(i,m,j) = 0.25*( uu( i , m , j )+uu( i , m ,j-1)
     :                    +uu( i ,m-1, j )+uu( i ,m-1,j-1) )
     :                *( ( v ( i , m , j )-v ( i ,m-1, j ) ) / dz
     :                  +( w ( i , m , j )-w ( i , m ,j-1) ) / dy )
      end do
      end do
      end do
c
c  ***  Boundary condition  ***
      do j = 1,ny
      do i = 1,nx
        wu(i,   1,j) = 0.0
        vw(i,   1,j) = 0.0
      end do
      end do
c
      call sub_bc ( mx, mz, nx, nz, ny, uv )
      call sub_bc ( mx, mz, nx, nz, ny, wu )
      call sub_bc ( mx, mz, nx, nz, ny, vw )
c
      return
      end
