c **********************************************************************
c *   Depth of the ABL and the convective velocity                     *
c *                                                                    *
c *   # wtv is calculated from sub_flux_v.f.                           *
c *   # see function ktop_search in src/sgs.f.                         *
c **********************************************************************
c
      subroutine  sub_ziwst ( ziin,
     i                  mx, mz, nx, nz, ny, dx, dz, dy, tref,
     i                  u, v, wtv, flm,
     w                  wtav,
     o                  zi, wst, ust )
c
      include  "../src/Implicit.h"
c
      dimension  u (mx,mz,ny), v (mx,mz,ny), wtv(mx,mz,ny)
      dimension  flm(mx,ny)
      dimension  wtav(mz)
c
      rsum = 1.0/dble((nx-2)*(ny-2))
      gtr  = 9.81/tref
c
      do k = 1,nz+1
        wtav(k) = 0.0
        do j = 2,ny-1
        do i = 2,nx-1
          wtav(k) = wtav(k) +wtv(i,k,j)
        end do
        end do
        wtav(k) = wtav(k) * rsum
      end do
c
        uav = 0.0
        vav = 0.0
        fav = 0.0
        do j = 2,ny-1
        do i = 2,nx-1
          uav = uav +u (i,1,j)
          vav = vav +v (i,1,j)
          fav = fav -flm(i,j)
        end do
        end do
c
      ust = sqrt( fav*sqrt( uav**2+vav**2 ) ) * rsum
      wst = ust
c
      if     ( ziin    .gt. 0.0 ) then
        zi  = ziin
c
c  **  Stable  **
      elseif ( wtav(1) .lt. 0.0 ) then
        flux = 0.05 * wtav(1)
c
        do k = 2,nz
          zi1  = dz*( k-1 )
          if ( wtav(k) .gt. flux ) exit
        end do
c
        flux = -1.0e10
c
        do k = 2,nz
          if ( wtav(k) .lt. flux ) cycle
          flux = wtav(k)
          zi2  = dz*( k-1 )
        end do
c
        zi  = min( zi1, zi2 )
c
c  **  Unstable  **
      else
        flux = 1.0e10
c
        do k = 2,nz
          if ( wtav(k) .gt. flux ) cycle
          flux = wtav(k)
          zi   = dz*( k-1 )
        end do
c
      end if
c
      if ( wtav(1) .gt. 0.0 )
     :  wst = ( gtr*wtav(1)*zi )**( 1.0/3.0 )
c
      return
      end
