c **********************************************************************
c *   Addition of a bubble to flow fields                              *
c *                                                                    *
c *   Input variables:                                                 *
c *     xbub, ...zbub : Coordinates at the center of the bubble   (m)  *
c *     xbr           : Radius of the bubble in the x direction   (m)  *
c *     ybr, zbr      : Same as above but for the y and z direction    *
c *     tbub          : Potential temp. at the center of the bubble    *
c *                   : For the present, this value is given to all    *
c *                   : grids within the bubble                   (K)  *
c **********************************************************************
c
      subroutine  add_bubble ( xbub, ybub, zbub, xbr, ybr, zbr, tbub )
c
      include  "Declare.h"
c
      if ( xbub .lt. 0.0 .or. xbub .gt. nx*dx ) return
c
      ist = max( int((xbub-xbr)/dx)+1,  1 )
      ied = min( int((xbub+xbr)/dx)+1, nx )
      jst = max( int((ybub-ybr)/dy)+1,  1 )
      jed = min( int((ybub+ybr)/dy)+1, ny )
      kst = max( int((zbub-zbr)/dz)+1,  1 )
      ked = min( int((zbub+zbr)/dz)+1, nz )
c
      do j = jst,jed
      do k = kst,ked
      do i = ist,ied
c?      wgt = sqrt( ( (i-0.5)*dx-xbub )**2/xbr**2
c?   :             +( (j-0.5)*dy-ybub )**2/ybr**2
c?   :             +( (k-0.5)*dz-zbub )**2/zbr**2 )
c?      if ( wgt .gt. 1.0 ) wgt = 1.0
c
c?      t (i,k,j) = t (i,k,j)*wgt + ( tbub-tref )*( 1.0-wgt )
c
        t (i,k,j) = tbub -tref
      end do
      end do
      end do
c
      return
      end
