c **********************************************************************
c *   Condensation process                                             *
c **********************************************************************
c
      subroutine  condensation
c
      include  "Declare.h"
c
      do j = 2,ny-1
      do k = 1,nz
      do i = 1,mx
        p2a = 0.5*( pi( i ,k+1, j )+pi0( i ,k+1, j )
     :             +pi( i , k , j )+pi0( i , k , j ) ) / cp
        tt  = p2a*( t ( i , k , j )+tref ) - t0
c
cx      if ( tt .gt. 0.0 ) then
          a  =  17.27
          b  = 237.30
cx      else
cx        a  =  21.87
cx        b  = 265.50
cx      end if
c
c  ***  Tetens formula; 3.8 = 6.11*0.622 (kg/kg)  ***
        qsl  = 3.8 * exp ( a*tt/( b+tt ) )
     :             / sqrt( p ( i ,k+1, j )*p (i,k,j) )
c
c  ***  Clausius-Clapeyron equation  ***
        dqsl = 0.622 * qsl * ev / ( rd*( tt+t0 )**2 )
c
        if ( q (i,k,j) .gt. qsl ) then
          alph = 1.0  / ( 1.0 + dqsl*ev/cp )
          qln  = alph * ( q (i,k,j) - qsl )
          pp   = 2.0*ev / ( pi0( i ,k+1, j )+pi0(i,k,j) )
          pt   = t (i,k,j) +tref +qln*pp
          qt   = 1.0 +0.61*q (i,k,j) -1.61*qln
          gamm = alph * ( pp*qt - 1.61*pt )
c
          ql (i,k,j) =  qln
          vt (i,k,j) = -1.61*qln    -gamm*dqsl*ev/( cp*pp )
          vq (i,k,j) =  0.61*qln*pp +gamm
          cld(i,k,j) =  1.0
c
        else
          ql (i,k,j) =  0.0
          vt (i,k,j) =  0.0
          vq (i,k,j) =  0.0
          cld(i,k,j) =  0.0
c
        end if
      end do
      end do
      end do
c
c  ***  Boundary values below are not used in the simulation.  ***
c?    call bc_lat_scalar ( ql  )
c?    call bc_lat_scalar ( vt  )
c?    call bc_lat_scalar ( vq  )
c?    call bc_lat_scalar ( cld )
c
c?    call bc_upp_scalar ( ql, 0.0 )
c
      return
      end
