c **********************************************************************
c *   Input/Output of the simulated distributions                      *
c *                                                                    *
c *   Input variables:                                                 *
c *     f_io          : Portion of the file name relevant to Run no.   *
c *                                                                    *
c *   # I/O devices are numbered orderly from 21.                      *
c **********************************************************************
c
      block data io_file_name
c
      include  "IOfile.h"
c
      data  f_name /
     3              'u___', 'v___', 'w___', 't___', 'q___',
     3              'fub_', 'fvb_', 'fwb_', 'ftb_', 'fqb_',
     3              'fm__', 'fh__', 'pd__', 'vt__', 'vq__',
     3              'ql__', 'rhr_', 'rfx_', 'wsb_',
     3              'sa__', 'fab_', 'xxxx', 'xxxx',
     2              'flm_', 'flt_', 'flq_', 'ts__',
     1              'gam_', 'fwu_', 'fvw_'                /
c
      end
c **********************************************************************
c
      subroutine  data_selection ( isgs, isfc, irad, icon, isca )
c
      include  "IOfile.h"
c
      do i = 1,mf
        select case ( f_name(i) )
cx        case ( 'q___', 'fqb_', 'flq_' )
          case (         'fqb_'         )
            if ( icon .lt. 0            ) f_name(i) = 'xxxx'
          case ( 'vt__', 'vq__', 'ql__' )
            if ( icon .lt. 1            ) f_name(i) = 'xxxx'
          case ( 'rhr_', 'rfx_'         )
            if ( irad .eq. 0            ) f_name(i) = 'xxxx'
          case ( 'wsb_'                 )
            if ( isfc .lt. 3            ) f_name(i) = 'xxxx'
          case ( 'sa__', 'fab_'         )
            if ( isca .eq. 0            ) f_name(i) = 'xxxx'
          case ( 'ts__'                 )
            if ( isfc .ne. 0            ) f_name(i) = 'xxxx'
          case ( 'gam_', 'fwu_', 'fvw_' )
            if ( isgs .eq. 0            ) f_name(i) = 'xxxx'
        end select
      end do
c
      return
      end
c **********************************************************************
c
      subroutine  data_open ( f_io )
c
      include  "IOfile.h"
c
      character (len=5) :: f_io
c
      do i = 1,mf
        if ( f_name(i) .ne. 'xxxx' )
     :    open ( i+20,file=f_name(i)//f_io,form='unformatted' )
      end do
c
      return
      end
c **********************************************************************
c
      subroutine  data_close
c
      include  "IOfile.h"
c
      do i = 1,mf
        close ( i+20 )
      end do
c
      return
      end
c **********************************************************************
c
      subroutine  data_output
c
      include  "Declare.h"
      include  "IOfile.h"
c
      do i = 1,mf
        mt = i +20
c
        select case ( f_name(i) )
          case ( 'u___' );  write(mt)  u
          case ( 'v___' );  write(mt)  v
          case ( 'w___' );  write(mt)  w
          case ( 't___' );  write(mt)  t
          case ( 'q___' );  write(mt)  q
          case ( 'fub_' );  write(mt)  fub
          case ( 'fvb_' );  write(mt)  fvb
          case ( 'fwb_' );  write(mt)  fwb
          case ( 'ftb_' );  write(mt)  ftb
          case ( 'fqb_' );  write(mt)  fqb
          case ( 'fm__' );  write(mt)  fm
          case ( 'fh__' );  write(mt)  fh
          case ( 'pd__' );  write(mt)  pd
          case ( 'vt__' );  write(mt)  vt
          case ( 'vq__' );  write(mt)  vq
          case ( 'ql__' );  write(mt)  ql
          case ( 'rhr_' );  write(mt)  rhr
          case ( 'rfx_' );  write(mt)  rfx
          case ( 'wsb_' );  write(mt)  wsb
          case ( 'sa__' );  write(mt)  sa
          case ( 'fab_' );  write(mt)  fab
          case ( 'flm_' );  write(mt)  flm
          case ( 'flt_' );  write(mt)  flt
          case ( 'flq_' );  write(mt)  flq
          case ( 'ts__' );  write(mt)  ts
          case ( 'gam_' );  write(mt)  gam
          case ( 'fwu_' );  write(mt)  fwu
          case ( 'fvw_' );  write(mt)  fvw
        end select
c
      end do
c
      return
      end
c **********************************************************************
c
      subroutine  data_restart ( f_io )
c
c     gam, fwu, and fvw do not need to be restored,
c     since they are computed in subroutine sgs_model.
c
      include  "Declare.h"
      include  "IOfile.h"
c
      character (len=5) :: f_io
c
      call data_open ( f_io )
c
      do i = 1,mf
        mt = i +20
c
      do j = 1,999
        select case ( f_name(i) )
          case ( 'u___' );  read (mt,end=100)  u
          case ( 'v___' );  read (mt,end=100)  v
          case ( 'w___' );  read (mt,end=100)  w
          case ( 't___' );  read (mt,end=100)  t
          case ( 'q___' );  read (mt,end=100)  q
          case ( 'fub_' );  read (mt,end=100)  fub
          case ( 'fvb_' );  read (mt,end=100)  fvb
          case ( 'fwb_' );  read (mt,end=100)  fwb
          case ( 'ftb_' );  read (mt,end=100)  ftb
          case ( 'fqb_' );  read (mt,end=100)  fqb
          case ( 'fm__' );  read (mt,end=100)  fm
          case ( 'fh__' );  read (mt,end=100)  fh
          case ( 'pd__' );  read (mt,end=100)  pd
          case ( 'vt__' );  read (mt,end=100)  vt
          case ( 'vq__' );  read (mt,end=100)  vq
          case ( 'ql__' );  read (mt,end=100)  ql
          case ( 'rhr_' );  read (mt,end=100)  rhr
          case ( 'rfx_' );  read (mt,end=100)  rfx
          case ( 'wsb_' );  read (mt,end=100)  wsb
          case ( 'sa__' );  read (mt,end=100)  sa
          case ( 'fab_' );  read (mt,end=100)  fab
          case ( 'flm_' );  read (mt,end=100)  flm
          case ( 'flt_' );  read (mt,end=100)  flt
          case ( 'flq_' );  read (mt,end=100)  flq
          case ( 'ts__' );  read (mt,end=100)  ts
          case default;     goto 100
        end select
      end do
c
  100 continue
      end do
c
      call data_close
c
      return
      end
