c **********************************************************************
c *   Subtraction of the hydrostatic balance and the horizontal mean   *
c *   from the equation for the vertical velocity                      *
c *                                                                    *
c *   # If this procedure is omitted, pd results in containing the     *
c *     hydrostatic pressure. This result has no influence on the      *
c *     other statistical quantities. Considering that p_h >> p_d,     *
c *     however, this procedure may be to be carried out.              *
c **********************************************************************
c
      subroutine  hydro_subtraction
c
      include  "Declare.h"
c
      rsum = 1.0 /dble((nx-2)*(ny-2))
c
      do k = 1,nz
        bav = 0.0
        wav = 0.0
        pav = 0.0
c
      do j = 2,ny-1
      do i = 2,nx-1
        bav = bav +bv(i,k,j)
        wav = wav +ww(i,k,j)
        pav = pav +pd(i,k,j)
      end do
      end do
c
        bav = bav * rsum
        wav = wav * rsum
        pav = pav * rsum
c
      do j = 1,ny-1
      do i = 1,nx-1
        bv(i,k,j) = bv(i,k,j) -bav
        ww(i,k,j) = ww(i,k,j) -wav
        pd(i,k,j) = pd(i,k,j) -pav
      end do
      end do
c
      end do
c
      return
      end
