c **********************************************************************
c *   Initialization                                                   *
c **********************************************************************
c
      subroutine  initialization ( ugsf, vgsf, tsf, psf )
c
      include  "Declare.h"
      include  "IOfile.h"
c
c  ***  Wind, Potential temperature, and so on  ***
      do j = 1,ny
      do k = 1,mz
      do i = 1,mx
        u  (i,k,j) = ui(k)
        v  (i,k,j) = vi(k)
        w  (i,k,j) = 0.0
c
        t  (i,k,j) = ti(k)
        q  (i,k,j) = qi(k)
      end do
      end do
      end do
c
      call exner_pressure ( psf, ugsf, vgsf )
c
c  ***  Soil temperature  ***
      do j = 1,ny
      do i = 1,nx
        ts(i,j) = tsf*( pi(i,1,j)+pi0(i,1,j) )/cp - tref
      end do
      end do
c
      return
      end
c
      subroutine  exner_pressure ( psf, ugsf, vgsf )
c
      include  "Declare.h"
c
      gtr  = g /tref
      gtz  = g /tref**2 * dz
      fwt  = fs/tref
      pibm = cp*( psf/p0 )**( rd/cp )
c
c  ***  Adjusts pibm so that pi+pi0 at the surface is equal to pibm  ***
      do k = 1,nz
        pibm = pibm +gtz*( ( ti(k)+tref       )
     :                    *( 1.0  +0.61*qi(k) )-tref )
      end do
c
      do j = 1,ny
      do k = 1,mz
      do i = 1,mx
        pi (i,k,j) = 0.0
        pi0(i,k,j) = pibm -gtr * dz*( k-1.0 )
cx   :     +fwt*( vgsf*dx*( i-(nx+1)/2.0 )-ugsf*dy*( j-(ny+1)/2.0 ) )
c
        p  (i,k,j) = p0*( pi0(i,k,j)/cp )**( cp/rd )
      end do
      end do
      end do
c
      call hydro_pressure
c
cx    write(6,*) 'pibm, pi(surface) =', pibm, pi(2,1,2)
c
      return
      end
