c **********************************************************************
c *   Physical process term                                            *
c *                                                                    *
c *   Input variables:                                                 *
c *     iphy          : = 4,       for potential temperature           *
c *                   : = 5,       for specific humidity               *
c *                   : otherwise, in the case of no physical process  *
c **********************************************************************
c
      subroutine  physical_term ( iphy )
c
      include  "Declare.h"
c
      if     ( iphy .eq. 4                    ) then
        ctw = 0.25 * fs*tref/g
c
        do j = 2,ny-1
        do k = 1,nz
        do i = 2,nx-1
          uv(i,k,j) = rhr( i ,k+1, j )
     :     +ctw*( ( v( i ,k,j+1)+v(i,k,j) )*( ug(k+1)-ug(k-1) )
     :           -( u(i+1,k, j )+u(i,k,j) )*( vg(k+1)-vg(k-1) ) ) / dz
        end do
        end do
        end do
c
        if   (                   gno .gt. 0.0 ) then
c
        do j = 2,ny-1
        do k = 1,nz
        do i = 1,mx
          uv(i,k,j) = uv(i,k,j)
     :               -2.0*ev/( pi0( i ,k+1, j )+pi0(i,k,j) )
     :               *gno*( ql( i ,k+1, j )**gpw
     :                     -ql( i , k , j )**gpw ) / dz
        end do
        end do
        end do
c
        end if
c
      elseif ( iphy .eq. 5 .and. gno .gt. 0.0 ) then
        do j = 2,ny-1
        do k = 1,nz
        do i = 1,mx
          uv(i,k,j) = gno*( ql( i ,k+1, j )**gpw
     :                     -ql( i , k , j )**gpw ) / dz
        end do
        end do
        end do
c
      else
        do j = 2,ny-1
        do k = 1,nz
        do i = 1,mx
          uv(i,k,j) = 0.0
        end do
        end do
        end do
c
      end if
c
      return
      end
