c **********************************************************************
c *   Time average of the surface velocity                             *
c *                                                                    *
c *   Input variables:                                                 *
c *     istep         : Time-step number                               *
c *                                                                    *
c *   # The surface velocity for about one minute is stored in wsb,    *
c *     which is used in sub.surface_prescript with isfc > 2.          *
c **********************************************************************
c
      subroutine  time_average ( istep )
c
      include  "Declare.h"
c
      parameter ( mz1=mz-1 )
c
      iskip = max( 60.0/( dt*mz1 )+0.5, 1.0 )
c
      if ( mod( istep-1, iskip ) .eq. 0 ) then
        nws = ( istep-1 ) / iskip
        mws = mod( nws, mz1 ) +1
c
        if ( nws .lt. mz1 ) then
          do j = 2,ny-1
          do i = 2,nx-1
            wsb(i,mws,j) =  sqrt( u (i,1,j)**2 + v (i,1,j)**2 )
            wsb(i,mz, j) = ( wsb(i,mz,j)*nws        +wsb(i,mws,j) )
     :                    / real( nws+1 )
          end do
          end do
c
        else
          do j = 2,ny-1
          do i = 2,nx-1
            wsold        =  wsb(i,mws,j)
            wsb(i,mws,j) =  sqrt( u (i,1,j)**2 + v (i,1,j)**2 )
            wsb(i,mz, j) = ( wsb(i,mz,j)*mz1 -wsold +wsb(i,mws,j) )
     :                    / real( mz1 )
          end do
          end do
c
        end if
      end if
c
      return
      end
